import * as _openid4vc_oauth2 from '@openid4vc/oauth2';
import { PreAuthorizedCodeGrantIdentifier, AuthorizationCodeGrantIdentifier, AuthorizationServerMetadata, ResourceRequestResponseOk, ResourceRequestResponseNotOk, CallbackContext, RequestDpopOptions, JwtSigner, CreateAuthorizationRequestUrlOptions, CreatePkceReturn, RetrievePreAuthorizedCodeAccessTokenOptions, RetrieveAuthorizationCodeAccessTokenOptions, preAuthorizedCodeGrantIdentifier, authorizationCodeGrantIdentifier } from '@openid4vc/oauth2';
import * as v from 'valibot';
import { SafeParseResult } from 'valibot';
import { InferOutputUnion, Fetch } from '@openid4vc/utils';
export { Oid4vcTsConfig, getGlobalConfig, setGlobalConfig } from '@openid4vc/utils';

declare const vTxCode: v.LooseObjectSchema<{
    readonly input_mode: v.OptionalSchema<v.UnionSchema<[v.LiteralSchema<"numeric", undefined>, v.LiteralSchema<"text", undefined>], undefined>, never>;
    readonly length: v.OptionalSchema<v.SchemaWithPipe<[v.NumberSchema<undefined>, v.IntegerAction<number, undefined>]>, never>;
    readonly description: v.OptionalSchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.MaxLengthAction<string, 300, undefined>]>, never>;
}, undefined>;
type CredentialOfferPreAuthorizedCodeGrantTxCode = v.InferInput<typeof vTxCode>;
declare const vCredentialOfferGrants: v.LooseObjectSchema<{
    readonly authorization_code: v.OptionalSchema<v.LooseObjectSchema<{
        readonly issuer_state: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly authorization_server: v.OptionalSchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.UrlAction<string, undefined>, v.CheckAction<string, "url must be an https:// url">]>, never>;
    }, undefined>, never>;
    readonly "urn:ietf:params:oauth:grant-type:pre-authorized_code": v.OptionalSchema<v.LooseObjectSchema<{
        readonly 'pre-authorized_code': v.StringSchema<undefined>;
        readonly tx_code: v.OptionalSchema<v.LooseObjectSchema<{
            readonly input_mode: v.OptionalSchema<v.UnionSchema<[v.LiteralSchema<"numeric", undefined>, v.LiteralSchema<"text", undefined>], undefined>, never>;
            readonly length: v.OptionalSchema<v.SchemaWithPipe<[v.NumberSchema<undefined>, v.IntegerAction<number, undefined>]>, never>;
            readonly description: v.OptionalSchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.MaxLengthAction<string, 300, undefined>]>, never>;
        }, undefined>, never>;
        readonly authorization_server: v.OptionalSchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.UrlAction<string, undefined>, v.CheckAction<string, "url must be an https:// url">]>, never>;
    }, undefined>, never>;
}, undefined>;
type CredentialOfferGrants = v.InferInput<typeof vCredentialOfferGrants>;
type CredentialOfferPreAuthorizedCodeGrant = CredentialOfferGrants[PreAuthorizedCodeGrantIdentifier];
type CredenialOfferAuthorizationCodeGrant = CredentialOfferGrants[AuthorizationCodeGrantIdentifier];
declare const vCredentialOfferObjectDraft14: v.LooseObjectSchema<{
    readonly credential_issuer: v.SchemaWithPipe<[v.StringSchema<undefined>, v.UrlAction<string, undefined>, v.CheckAction<string, "url must be an https:// url">]>;
    readonly credential_configuration_ids: v.ArraySchema<v.StringSchema<undefined>, undefined>;
    readonly grants: v.OptionalSchema<v.LooseObjectSchema<{
        readonly authorization_code: v.OptionalSchema<v.LooseObjectSchema<{
            readonly issuer_state: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly authorization_server: v.OptionalSchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.UrlAction<string, undefined>, v.CheckAction<string, "url must be an https:// url">]>, never>;
        }, undefined>, never>;
        readonly "urn:ietf:params:oauth:grant-type:pre-authorized_code": v.OptionalSchema<v.LooseObjectSchema<{
            readonly 'pre-authorized_code': v.StringSchema<undefined>;
            readonly tx_code: v.OptionalSchema<v.LooseObjectSchema<{
                readonly input_mode: v.OptionalSchema<v.UnionSchema<[v.LiteralSchema<"numeric", undefined>, v.LiteralSchema<"text", undefined>], undefined>, never>;
                readonly length: v.OptionalSchema<v.SchemaWithPipe<[v.NumberSchema<undefined>, v.IntegerAction<number, undefined>]>, never>;
                readonly description: v.OptionalSchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.MaxLengthAction<string, 300, undefined>]>, never>;
            }, undefined>, never>;
            readonly authorization_server: v.OptionalSchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.UrlAction<string, undefined>, v.CheckAction<string, "url must be an https:// url">]>, never>;
        }, undefined>, never>;
    }, undefined>, never>;
}, undefined>;
type CredentialOfferObject = v.InferInput<typeof vCredentialOfferObjectDraft14>;

declare const vCredentialRequestProof: v.IntersectSchema<[v.LooseObjectSchema<{
    readonly proof_type: v.StringSchema<undefined>;
}, undefined>, v.VariantSchema<"proof_type", [v.ObjectSchema<{
    readonly proof_type: v.LiteralSchema<"jwt", undefined>;
    readonly jwt: v.SchemaWithPipe<[v.StringSchema<undefined>, v.RegexAction<string, "Not a valid compact jwt">]>;
}, undefined>, v.ObjectSchema<{
    readonly proof_type: v.LiteralSchema<"attestation", undefined>;
    readonly attestation: v.SchemaWithPipe<[v.StringSchema<undefined>, v.RegexAction<string, "Not a valid compact jwt">]>;
}, undefined>, v.LooseObjectSchema<{
    readonly proof_type: v.SchemaWithPipe<[v.StringSchema<undefined>, v.CheckAction<string, undefined>]>;
}, undefined>], undefined>], undefined>;
declare const vCredentialRequestProofs: v.ObjectSchema<{
    readonly jwt: v.OptionalSchema<v.ArraySchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.RegexAction<string, "Not a valid compact jwt">]>, undefined>, never>;
    readonly attestation: v.OptionalSchema<v.ArraySchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.RegexAction<string, "Not a valid compact jwt">]>, undefined>, never>;
}, undefined>;
type CredentialRequestProof = v.InferOutput<typeof vCredentialRequestProof>;
type CredentialRequestProofsFormatSpecific = v.InferOutput<typeof vCredentialRequestProofs>;
type CredentialRequestProofs = v.InferOutput<typeof vCredentialRequestProofs>;
declare const vCredentialRequestCommon: v.SchemaWithPipe<[v.LooseObjectSchema<{
    readonly proof: v.OptionalSchema<v.IntersectSchema<[v.LooseObjectSchema<{
        readonly proof_type: v.StringSchema<undefined>;
    }, undefined>, v.VariantSchema<"proof_type", [v.ObjectSchema<{
        readonly proof_type: v.LiteralSchema<"jwt", undefined>;
        readonly jwt: v.SchemaWithPipe<[v.StringSchema<undefined>, v.RegexAction<string, "Not a valid compact jwt">]>;
    }, undefined>, v.ObjectSchema<{
        readonly proof_type: v.LiteralSchema<"attestation", undefined>;
        readonly attestation: v.SchemaWithPipe<[v.StringSchema<undefined>, v.RegexAction<string, "Not a valid compact jwt">]>;
    }, undefined>, v.LooseObjectSchema<{
        readonly proof_type: v.SchemaWithPipe<[v.StringSchema<undefined>, v.CheckAction<string, undefined>]>;
    }, undefined>], undefined>], undefined>, never>;
    readonly proofs: v.OptionalSchema<v.SchemaWithPipe<[v.IntersectSchema<[v.RecordSchema<v.StringSchema<undefined>, v.ArraySchema<v.UnknownSchema, undefined>, undefined>, v.ObjectSchema<{
        readonly jwt: v.OptionalSchema<v.ArraySchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.RegexAction<string, "Not a valid compact jwt">]>, undefined>, never>;
        readonly attestation: v.OptionalSchema<v.ArraySchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.RegexAction<string, "Not a valid compact jwt">]>, undefined>, never>;
    }, undefined>], undefined>, v.CheckAction<{
        [x: string]: unknown[];
    } & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, "The 'proofs' object in a credential request should contain exactly one attribute">]>, never>;
    readonly credential_response_encryption: v.OptionalSchema<v.LooseObjectSchema<{
        readonly jwk: v.LooseObjectSchema<{
            readonly kty: v.StringSchema<undefined>;
            readonly crv: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly x: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly y: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly e: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly n: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly alg: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly d: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly dp: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly dq: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly ext: v.OptionalSchema<v.BooleanSchema<undefined>, never>;
            readonly k: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly key_ops: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly kid: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly oth: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                readonly d: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly r: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly t: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, undefined>, never>;
            readonly p: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly q: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly qi: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly use: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly x5c: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly x5t: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly 'x5t#S256': v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly x5u: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>;
        readonly alg: v.StringSchema<undefined>;
        readonly enc: v.StringSchema<undefined>;
    }, undefined>, never>;
}, undefined>, v.CheckAction<{
    proof?: ({
        proof_type: string;
    } & {
        [key: string]: unknown;
    } & ({
        attestation: string;
        proof_type: "attestation";
    } | {
        jwt: string;
        proof_type: "jwt";
    } | ({
        proof_type: string;
    } & {
        [key: string]: unknown;
    }))) | undefined;
    proofs?: ({
        [x: string]: unknown[];
    } & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }) | undefined;
    credential_response_encryption?: ({
        alg: string;
        jwk: {
            kty: string;
            crv?: string | undefined;
            x?: string | undefined;
            y?: string | undefined;
            e?: string | undefined;
            n?: string | undefined;
            alg?: string | undefined;
            d?: string | undefined;
            dp?: string | undefined;
            dq?: string | undefined;
            ext?: boolean | undefined;
            k?: string | undefined;
            key_ops?: string | undefined;
            kid?: string | undefined;
            oth?: ({
                d?: string | undefined;
                r?: string | undefined;
                t?: string | undefined;
            } & {
                [key: string]: unknown;
            })[] | undefined;
            p?: string | undefined;
            q?: string | undefined;
            qi?: string | undefined;
            use?: string | undefined;
            x5c?: string | undefined;
            x5t?: string | undefined;
            'x5t#S256'?: string | undefined;
            x5u?: string | undefined;
        } & {
            [key: string]: unknown;
        };
        enc: string;
    } & {
        [key: string]: unknown;
    }) | undefined;
} & {
    [key: string]: unknown;
}, "Both 'proof' and 'proofs' are defined. Only one is allowed">]>;

declare const allCredentialRequestFormats: readonly [v.ObjectSchema<{
    readonly format: v.LiteralSchema<"vc+sd-jwt", undefined>;
    readonly vct: v.StringSchema<undefined>;
    readonly claims: v.OptionalSchema<v.LooseObjectSchema<{
        readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, never>;
        readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly display: v.OptionalSchema<v.LooseObjectSchema<{
            readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, never>;
    }, undefined>, never>;
}, undefined>, v.ObjectSchema<{
    readonly format: v.LiteralSchema<"mso_mdoc", undefined>;
    readonly doctype: v.StringSchema<undefined>;
    readonly claims: v.OptionalSchema<v.LooseObjectSchema<{
        readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, never>;
        readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly display: v.OptionalSchema<v.LooseObjectSchema<{
            readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, never>;
    }, undefined>, never>;
}, undefined>, v.ObjectSchema<{
    readonly format: v.LiteralSchema<"ldp_vc", undefined>;
    readonly credential_definition: v.LooseObjectSchema<{
        readonly '@context': v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly type: v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly credentialSubject: v.OptionalSchema<v.RecordSchema<v.StringSchema<undefined>, v.UnionSchema<[v.ArraySchema<v.AnySchema, undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>, v.LooseObjectSchema<{
            readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, false>;
            readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, undefined>, never>;
        }, undefined>], undefined>, undefined>, never>;
    }, undefined>;
}, undefined>, v.ObjectSchema<{
    readonly format: v.LiteralSchema<"jwt_vc_json-ld", undefined>;
    readonly credential_definition: v.LooseObjectSchema<{
        readonly '@context': v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly type: v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly credentialSubject: v.OptionalSchema<v.RecordSchema<v.StringSchema<undefined>, v.UnionSchema<[v.ArraySchema<v.AnySchema, undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>, v.LooseObjectSchema<{
            readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, false>;
            readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, undefined>, never>;
        }, undefined>], undefined>, undefined>, never>;
    }, undefined>;
}, undefined>, v.ObjectSchema<{
    readonly format: v.LiteralSchema<"jwt_vc_json", undefined>;
    readonly credential_definition: v.LooseObjectSchema<{
        readonly type: v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly credentialSubject: v.OptionalSchema<v.RecordSchema<v.StringSchema<undefined>, v.UnionSchema<[v.ArraySchema<v.AnySchema, undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>, v.LooseObjectSchema<{
            readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, false>;
            readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, undefined>, never>;
        }, undefined>], undefined>, undefined>, never>;
    }, undefined>;
}, undefined>];
declare const vCredentialRequestDraft14: v.UnionSchema<[v.IntersectSchema<[v.SchemaWithPipe<[v.LooseObjectSchema<{
    readonly proof: v.OptionalSchema<v.IntersectSchema<[v.LooseObjectSchema<{
        readonly proof_type: v.StringSchema<undefined>;
    }, undefined>, v.VariantSchema<"proof_type", [v.ObjectSchema<{
        readonly proof_type: v.LiteralSchema<"jwt", undefined>;
        readonly jwt: v.SchemaWithPipe<[v.StringSchema<undefined>, v.RegexAction<string, "Not a valid compact jwt">]>;
    }, undefined>, v.ObjectSchema<{
        readonly proof_type: v.LiteralSchema<"attestation", undefined>;
        readonly attestation: v.SchemaWithPipe<[v.StringSchema<undefined>, v.RegexAction<string, "Not a valid compact jwt">]>;
    }, undefined>, v.LooseObjectSchema<{
        readonly proof_type: v.SchemaWithPipe<[v.StringSchema<undefined>, v.CheckAction<string, undefined>]>;
    }, undefined>], undefined>], undefined>, never>;
    readonly proofs: v.OptionalSchema<v.SchemaWithPipe<[v.IntersectSchema<[v.RecordSchema<v.StringSchema<undefined>, v.ArraySchema<v.UnknownSchema, undefined>, undefined>, v.ObjectSchema<{
        readonly jwt: v.OptionalSchema<v.ArraySchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.RegexAction<string, "Not a valid compact jwt">]>, undefined>, never>;
        readonly attestation: v.OptionalSchema<v.ArraySchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.RegexAction<string, "Not a valid compact jwt">]>, undefined>, never>;
    }, undefined>], undefined>, v.CheckAction<{
        [x: string]: unknown[];
    } & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, "The 'proofs' object in a credential request should contain exactly one attribute">]>, never>;
    readonly credential_response_encryption: v.OptionalSchema<v.LooseObjectSchema<{
        readonly jwk: v.LooseObjectSchema<{
            readonly kty: v.StringSchema<undefined>;
            readonly crv: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly x: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly y: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly e: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly n: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly alg: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly d: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly dp: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly dq: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly ext: v.OptionalSchema<v.BooleanSchema<undefined>, never>;
            readonly k: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly key_ops: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly kid: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly oth: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                readonly d: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly r: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly t: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, undefined>, never>;
            readonly p: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly q: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly qi: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly use: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly x5c: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly x5t: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly 'x5t#S256': v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly x5u: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>;
        readonly alg: v.StringSchema<undefined>;
        readonly enc: v.StringSchema<undefined>;
    }, undefined>, never>;
}, undefined>, v.CheckAction<{
    proof?: ({
        proof_type: string;
    } & {
        [key: string]: unknown;
    } & ({
        attestation: string;
        proof_type: "attestation";
    } | {
        jwt: string;
        proof_type: "jwt";
    } | ({
        proof_type: string;
    } & {
        [key: string]: unknown;
    }))) | undefined;
    proofs?: ({
        [x: string]: unknown[];
    } & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }) | undefined;
    credential_response_encryption?: ({
        alg: string;
        jwk: {
            kty: string;
            crv?: string | undefined;
            x?: string | undefined;
            y?: string | undefined;
            e?: string | undefined;
            n?: string | undefined;
            alg?: string | undefined;
            d?: string | undefined;
            dp?: string | undefined;
            dq?: string | undefined;
            ext?: boolean | undefined;
            k?: string | undefined;
            key_ops?: string | undefined;
            kid?: string | undefined;
            oth?: ({
                d?: string | undefined;
                r?: string | undefined;
                t?: string | undefined;
            } & {
                [key: string]: unknown;
            })[] | undefined;
            p?: string | undefined;
            q?: string | undefined;
            qi?: string | undefined;
            use?: string | undefined;
            x5c?: string | undefined;
            x5t?: string | undefined;
            'x5t#S256'?: string | undefined;
            x5u?: string | undefined;
        } & {
            [key: string]: unknown;
        };
        enc: string;
    } & {
        [key: string]: unknown;
    }) | undefined;
} & {
    [key: string]: unknown;
}, "Both 'proof' and 'proofs' are defined. Only one is allowed">]>, v.UnionSchema<[v.ObjectSchema<{
    readonly format: v.LiteralSchema<"vc+sd-jwt", undefined>;
    readonly vct: v.StringSchema<undefined>;
    readonly claims: v.OptionalSchema<v.LooseObjectSchema<{
        readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, never>;
        readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly display: v.OptionalSchema<v.LooseObjectSchema<{
            readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, never>;
    }, undefined>, never>;
}, undefined>, v.ObjectSchema<{
    readonly format: v.LiteralSchema<"mso_mdoc", undefined>;
    readonly doctype: v.StringSchema<undefined>;
    readonly claims: v.OptionalSchema<v.LooseObjectSchema<{
        readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, never>;
        readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly display: v.OptionalSchema<v.LooseObjectSchema<{
            readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, never>;
    }, undefined>, never>;
}, undefined>, v.ObjectSchema<{
    readonly format: v.LiteralSchema<"ldp_vc", undefined>;
    readonly credential_definition: v.LooseObjectSchema<{
        readonly '@context': v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly type: v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly credentialSubject: v.OptionalSchema<v.RecordSchema<v.StringSchema<undefined>, v.UnionSchema<[v.ArraySchema<v.AnySchema, undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>, v.LooseObjectSchema<{
            readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, false>;
            readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, undefined>, never>;
        }, undefined>], undefined>, undefined>, never>;
    }, undefined>;
}, undefined>, v.ObjectSchema<{
    readonly format: v.LiteralSchema<"jwt_vc_json-ld", undefined>;
    readonly credential_definition: v.LooseObjectSchema<{
        readonly '@context': v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly type: v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly credentialSubject: v.OptionalSchema<v.RecordSchema<v.StringSchema<undefined>, v.UnionSchema<[v.ArraySchema<v.AnySchema, undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>, v.LooseObjectSchema<{
            readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, false>;
            readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, undefined>, never>;
        }, undefined>], undefined>, undefined>, never>;
    }, undefined>;
}, undefined>, v.ObjectSchema<{
    readonly format: v.LiteralSchema<"jwt_vc_json", undefined>;
    readonly credential_definition: v.LooseObjectSchema<{
        readonly type: v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly credentialSubject: v.OptionalSchema<v.RecordSchema<v.StringSchema<undefined>, v.UnionSchema<[v.ArraySchema<v.AnySchema, undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>, v.LooseObjectSchema<{
            readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, false>;
            readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, undefined>, never>;
        }, undefined>], undefined>, undefined>, never>;
    }, undefined>;
}, undefined>, v.LooseObjectSchema<{
    readonly format: v.SchemaWithPipe<[v.StringSchema<undefined>, v.CheckAction<string, undefined>]>;
}, undefined>], undefined>, v.ObjectSchema<{
    readonly credential_identifier: v.OptionalSchema<v.NeverSchema<"'credential_identifier' cannot be defined when 'format' is set.">, never>;
}, undefined>], undefined>, v.IntersectSchema<[v.SchemaWithPipe<[v.LooseObjectSchema<{
    readonly proof: v.OptionalSchema<v.IntersectSchema<[v.LooseObjectSchema<{
        readonly proof_type: v.StringSchema<undefined>;
    }, undefined>, v.VariantSchema<"proof_type", [v.ObjectSchema<{
        readonly proof_type: v.LiteralSchema<"jwt", undefined>;
        readonly jwt: v.SchemaWithPipe<[v.StringSchema<undefined>, v.RegexAction<string, "Not a valid compact jwt">]>;
    }, undefined>, v.ObjectSchema<{
        readonly proof_type: v.LiteralSchema<"attestation", undefined>;
        readonly attestation: v.SchemaWithPipe<[v.StringSchema<undefined>, v.RegexAction<string, "Not a valid compact jwt">]>;
    }, undefined>, v.LooseObjectSchema<{
        readonly proof_type: v.SchemaWithPipe<[v.StringSchema<undefined>, v.CheckAction<string, undefined>]>;
    }, undefined>], undefined>], undefined>, never>;
    readonly proofs: v.OptionalSchema<v.SchemaWithPipe<[v.IntersectSchema<[v.RecordSchema<v.StringSchema<undefined>, v.ArraySchema<v.UnknownSchema, undefined>, undefined>, v.ObjectSchema<{
        readonly jwt: v.OptionalSchema<v.ArraySchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.RegexAction<string, "Not a valid compact jwt">]>, undefined>, never>;
        readonly attestation: v.OptionalSchema<v.ArraySchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.RegexAction<string, "Not a valid compact jwt">]>, undefined>, never>;
    }, undefined>], undefined>, v.CheckAction<{
        [x: string]: unknown[];
    } & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }, "The 'proofs' object in a credential request should contain exactly one attribute">]>, never>;
    readonly credential_response_encryption: v.OptionalSchema<v.LooseObjectSchema<{
        readonly jwk: v.LooseObjectSchema<{
            readonly kty: v.StringSchema<undefined>;
            readonly crv: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly x: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly y: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly e: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly n: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly alg: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly d: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly dp: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly dq: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly ext: v.OptionalSchema<v.BooleanSchema<undefined>, never>;
            readonly k: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly key_ops: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly kid: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly oth: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                readonly d: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly r: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly t: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, undefined>, never>;
            readonly p: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly q: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly qi: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly use: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly x5c: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly x5t: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly 'x5t#S256': v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly x5u: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>;
        readonly alg: v.StringSchema<undefined>;
        readonly enc: v.StringSchema<undefined>;
    }, undefined>, never>;
}, undefined>, v.CheckAction<{
    proof?: ({
        proof_type: string;
    } & {
        [key: string]: unknown;
    } & ({
        attestation: string;
        proof_type: "attestation";
    } | {
        jwt: string;
        proof_type: "jwt";
    } | ({
        proof_type: string;
    } & {
        [key: string]: unknown;
    }))) | undefined;
    proofs?: ({
        [x: string]: unknown[];
    } & {
        jwt?: string[] | undefined;
        attestation?: string[] | undefined;
    }) | undefined;
    credential_response_encryption?: ({
        alg: string;
        jwk: {
            kty: string;
            crv?: string | undefined;
            x?: string | undefined;
            y?: string | undefined;
            e?: string | undefined;
            n?: string | undefined;
            alg?: string | undefined;
            d?: string | undefined;
            dp?: string | undefined;
            dq?: string | undefined;
            ext?: boolean | undefined;
            k?: string | undefined;
            key_ops?: string | undefined;
            kid?: string | undefined;
            oth?: ({
                d?: string | undefined;
                r?: string | undefined;
                t?: string | undefined;
            } & {
                [key: string]: unknown;
            })[] | undefined;
            p?: string | undefined;
            q?: string | undefined;
            qi?: string | undefined;
            use?: string | undefined;
            x5c?: string | undefined;
            x5t?: string | undefined;
            'x5t#S256'?: string | undefined;
            x5u?: string | undefined;
        } & {
            [key: string]: unknown;
        };
        enc: string;
    } & {
        [key: string]: unknown;
    }) | undefined;
} & {
    [key: string]: unknown;
}, "Both 'proof' and 'proofs' are defined. Only one is allowed">]>, v.ObjectSchema<{
    readonly credential_identifier: v.StringSchema<undefined>;
    readonly format: v.OptionalSchema<v.NeverSchema<"'format' cannot be defined when 'credential_identifier' is set.">, never>;
}, undefined>], undefined>], undefined>;
type CredentialRequestCommon = v.InferOutput<typeof vCredentialRequestCommon>;
type CredentialRequestFormatSpecific = InferOutputUnion<typeof allCredentialRequestFormats>;
type CredentialRequestWithFormats = CredentialRequestCommon & CredentialRequestFormatSpecific;
type CredentialRequest = v.InferOutput<typeof vCredentialRequestDraft14>;

interface ParseCredentialRequestOptions {
    credentialRequest: Record<string, unknown>;
}
interface ParseCredentialRequestReturn {
    /**
     * If the request was for a `format` that is known to this library it will have the
     * format specific data defined here. Will not be defined if the request is for an unknown format,
     * or if `credential_identifier` is used.
     */
    format?: CredentialRequestFormatSpecific;
    /**
     * If the request contains `proof` or `proofs` with a `proof_type` that is known to this
     * library it will have the proof type specific data defined here. Will not be defined
     * if the `proof_type` is not known or no `proof` or `proofs` were included.
     *
     * The `proof` property is parsed to the new proofs structure and the entries will
     * always only have a single entry in this case.
     *
     * NOTE: this value being `undefined` does NOT mean there were no proofs.
     * It means that either there were no proofs, or that the proof format is not
     * known to this library
     */
    proofs?: CredentialRequestProofsFormatSpecific;
    /**
     * If authorization details were used a `credential_identifier` will be included
     * in the request. Will not be defined if `format` is defined.
     */
    credentialIdentifier?: string;
    /**
     * The validated credential request. If both `format` and `credentialIdentifier` are
     * undefined you can still handle the request by using this object directly.
     */
    credentialRequest: CredentialRequest;
}

declare enum Oid4vciDraftVersion {
    Draft14 = "Draft14",
    Draft11 = "Draft11"
}

declare const vCredentialConfigurationSupportedCommon: v.LooseObjectSchema<{
    readonly format: v.StringSchema<undefined>;
    readonly scope: v.OptionalSchema<v.StringSchema<undefined>, never>;
    readonly cryptographic_binding_methods_supported: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
    readonly credential_signing_alg_values_supported: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
    readonly proof_types_supported: v.OptionalSchema<v.RecordSchema<v.UnionSchema<[v.LiteralSchema<"jwt", undefined>, v.LiteralSchema<"attestation", undefined>, v.StringSchema<undefined>], undefined>, v.ObjectSchema<{
        readonly proof_signing_alg_values_supported: v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly key_attestations_required: v.OptionalSchema<v.LooseObjectSchema<{
            readonly key_storage: v.OptionalSchema<v.ArraySchema<v.UnionSchema<[v.PicklistSchema<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"], undefined>, v.StringSchema<undefined>], undefined>, undefined>, never>;
            readonly user_authentication: v.OptionalSchema<v.ArraySchema<v.UnionSchema<[v.PicklistSchema<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"], undefined>, v.StringSchema<undefined>], undefined>, undefined>, never>;
        }, undefined>, never>;
    }, undefined>, undefined>, never>;
    readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
        readonly name: v.StringSchema<undefined>;
        readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly logo: v.OptionalSchema<v.LooseObjectSchema<{
            readonly uri: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly alt_text: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, never>;
        readonly description: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly background_color: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly background_image: v.OptionalSchema<v.LooseObjectSchema<{
            readonly uri: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, never>;
        readonly text_color: v.OptionalSchema<v.StringSchema<undefined>, never>;
    }, undefined>, undefined>, never>;
}, undefined>;

declare const allCredentialIssuerMetadataFormats: readonly [v.ObjectSchema<{
    readonly vct: v.StringSchema<undefined>;
    readonly format: v.LiteralSchema<"vc+sd-jwt", undefined>;
    readonly claims: v.OptionalSchema<v.LooseObjectSchema<{
        readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, never>;
        readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly display: v.OptionalSchema<v.LooseObjectSchema<{
            readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, never>;
    }, undefined>, never>;
    readonly order: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
}, undefined>, v.ObjectSchema<{
    readonly format: v.LiteralSchema<"mso_mdoc", undefined>;
    readonly doctype: v.StringSchema<undefined>;
    readonly claims: v.OptionalSchema<v.LooseObjectSchema<{
        readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, never>;
        readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly display: v.OptionalSchema<v.LooseObjectSchema<{
            readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, never>;
    }, undefined>, never>;
    readonly order: v.OptionalSchema<v.ArraySchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.IncludesAction<string, "~", undefined>]>, undefined>, never>;
}, undefined>, v.ObjectSchema<{
    readonly format: v.LiteralSchema<"jwt_vc_json-ld", undefined>;
    readonly credential_definition: v.LooseObjectSchema<{
        readonly '@context': v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly type: v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly credentialSubject: v.OptionalSchema<v.RecordSchema<v.StringSchema<undefined>, v.UnionSchema<[v.ArraySchema<v.AnySchema, undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>, v.LooseObjectSchema<{
            readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, false>;
            readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, undefined>, never>;
        }, undefined>], undefined>, undefined>, never>;
    }, undefined>;
    readonly order: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
}, undefined>, v.ObjectSchema<{
    readonly format: v.LiteralSchema<"ldp_vc", undefined>;
    readonly credential_definition: v.LooseObjectSchema<{
        readonly '@context': v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly type: v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly credentialSubject: v.OptionalSchema<v.RecordSchema<v.StringSchema<undefined>, v.UnionSchema<[v.ArraySchema<v.AnySchema, undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>, v.LooseObjectSchema<{
            readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, false>;
            readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, undefined>, never>;
        }, undefined>], undefined>, undefined>, never>;
    }, undefined>;
    readonly order: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
}, undefined>, v.ObjectSchema<{
    readonly format: v.LiteralSchema<"jwt_vc_json", undefined>;
    readonly credential_definition: v.LooseObjectSchema<{
        readonly type: v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly credentialSubject: v.OptionalSchema<v.RecordSchema<v.StringSchema<undefined>, v.UnionSchema<[v.ArraySchema<v.AnySchema, undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>, v.LooseObjectSchema<{
            readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, false>;
            readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, undefined>, never>;
        }, undefined>], undefined>, undefined>, never>;
    }, undefined>;
    readonly order: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
}, undefined>];
declare const vCredentialConfigurationSupportedWithFormats: v.IntersectSchema<[v.VariantSchema<"format", [v.ObjectSchema<{
    readonly vct: v.StringSchema<undefined>;
    readonly format: v.LiteralSchema<"vc+sd-jwt", undefined>;
    readonly claims: v.OptionalSchema<v.LooseObjectSchema<{
        readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, never>;
        readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly display: v.OptionalSchema<v.LooseObjectSchema<{
            readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, never>;
    }, undefined>, never>;
    readonly order: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
}, undefined>, v.ObjectSchema<{
    readonly format: v.LiteralSchema<"mso_mdoc", undefined>;
    readonly doctype: v.StringSchema<undefined>;
    readonly claims: v.OptionalSchema<v.LooseObjectSchema<{
        readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, never>;
        readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly display: v.OptionalSchema<v.LooseObjectSchema<{
            readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, never>;
    }, undefined>, never>;
    readonly order: v.OptionalSchema<v.ArraySchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.IncludesAction<string, "~", undefined>]>, undefined>, never>;
}, undefined>, v.ObjectSchema<{
    readonly format: v.LiteralSchema<"jwt_vc_json-ld", undefined>;
    readonly credential_definition: v.LooseObjectSchema<{
        readonly '@context': v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly type: v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly credentialSubject: v.OptionalSchema<v.RecordSchema<v.StringSchema<undefined>, v.UnionSchema<[v.ArraySchema<v.AnySchema, undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>, v.LooseObjectSchema<{
            readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, false>;
            readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, undefined>, never>;
        }, undefined>], undefined>, undefined>, never>;
    }, undefined>;
    readonly order: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
}, undefined>, v.ObjectSchema<{
    readonly format: v.LiteralSchema<"ldp_vc", undefined>;
    readonly credential_definition: v.LooseObjectSchema<{
        readonly '@context': v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly type: v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly credentialSubject: v.OptionalSchema<v.RecordSchema<v.StringSchema<undefined>, v.UnionSchema<[v.ArraySchema<v.AnySchema, undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>, v.LooseObjectSchema<{
            readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, false>;
            readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, undefined>, never>;
        }, undefined>], undefined>, undefined>, never>;
    }, undefined>;
    readonly order: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
}, undefined>, v.ObjectSchema<{
    readonly format: v.LiteralSchema<"jwt_vc_json", undefined>;
    readonly credential_definition: v.LooseObjectSchema<{
        readonly type: v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly credentialSubject: v.OptionalSchema<v.RecordSchema<v.StringSchema<undefined>, v.UnionSchema<[v.ArraySchema<v.AnySchema, undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>, v.LooseObjectSchema<{
            readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, false>;
            readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, undefined>, never>;
        }, undefined>], undefined>, undefined>, never>;
    }, undefined>;
    readonly order: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
}, undefined>, v.LooseObjectSchema<{
    readonly format: v.SchemaWithPipe<[v.StringSchema<undefined>, v.CheckAction<string, undefined>]>;
}, undefined>], undefined>, v.LooseObjectSchema<{
    readonly format: v.StringSchema<undefined>;
    readonly scope: v.OptionalSchema<v.StringSchema<undefined>, never>;
    readonly cryptographic_binding_methods_supported: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
    readonly credential_signing_alg_values_supported: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
    readonly proof_types_supported: v.OptionalSchema<v.RecordSchema<v.UnionSchema<[v.LiteralSchema<"jwt", undefined>, v.LiteralSchema<"attestation", undefined>, v.StringSchema<undefined>], undefined>, v.ObjectSchema<{
        readonly proof_signing_alg_values_supported: v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly key_attestations_required: v.OptionalSchema<v.LooseObjectSchema<{
            readonly key_storage: v.OptionalSchema<v.ArraySchema<v.UnionSchema<[v.PicklistSchema<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"], undefined>, v.StringSchema<undefined>], undefined>, undefined>, never>;
            readonly user_authentication: v.OptionalSchema<v.ArraySchema<v.UnionSchema<[v.PicklistSchema<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"], undefined>, v.StringSchema<undefined>], undefined>, undefined>, never>;
        }, undefined>, never>;
    }, undefined>, undefined>, never>;
    readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
        readonly name: v.StringSchema<undefined>;
        readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly logo: v.OptionalSchema<v.LooseObjectSchema<{
            readonly uri: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly alt_text: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, never>;
        readonly description: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly background_color: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly background_image: v.OptionalSchema<v.LooseObjectSchema<{
            readonly uri: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, never>;
        readonly text_color: v.OptionalSchema<v.StringSchema<undefined>, never>;
    }, undefined>, undefined>, never>;
}, undefined>], undefined>;
type CredentialConfigurationSupportedCommon = v.InferOutput<typeof vCredentialConfigurationSupportedCommon>;
type CredentialConfigurationSupportedFormatSpecific = InferOutputUnion<typeof allCredentialIssuerMetadataFormats>;
type CredentialConfigurationSupportedWithFormats = CredentialConfigurationSupportedFormatSpecific & CredentialConfigurationSupportedCommon;
type CredentialConfigurationsSupportedWithFormats = Record<string, CredentialConfigurationSupportedWithFormats>;
type CredentialConfigurationSupported = v.InferOutput<typeof vCredentialConfigurationSupportedWithFormats>;
type CredentialConfigurationsSupported = Record<string, CredentialConfigurationSupported>;
declare const vCredentialIssuerMetadataDisplayEntry: v.LooseObjectSchema<{
    readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
    readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
    readonly logo: v.OptionalSchema<v.LooseObjectSchema<{
        readonly uri: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly alt_text: v.OptionalSchema<v.StringSchema<undefined>, never>;
    }, undefined>, never>;
}, undefined>;
type CredentialIssuerMetadataDisplayEntry = v.InferOutput<typeof vCredentialIssuerMetadataDisplayEntry>;
type CredentialIssuerMetadata = v.InferOutput<typeof vCredentialIssuerMetadataDraft14>;
declare const vCredentialIssuerMetadataDraft14: v.LooseObjectSchema<{
    readonly credential_issuer: v.SchemaWithPipe<[v.StringSchema<undefined>, v.UrlAction<string, undefined>, v.CheckAction<string, "url must be an https:// url">]>;
    readonly authorization_servers: v.OptionalSchema<v.ArraySchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.UrlAction<string, undefined>, v.CheckAction<string, "url must be an https:// url">]>, undefined>, never>;
    readonly credential_endpoint: v.SchemaWithPipe<[v.StringSchema<undefined>, v.UrlAction<string, undefined>, v.CheckAction<string, "url must be an https:// url">]>;
    readonly deferred_credential_endpoint: v.OptionalSchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.UrlAction<string, undefined>, v.CheckAction<string, "url must be an https:// url">]>, never>;
    readonly notification_endpoint: v.OptionalSchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.UrlAction<string, undefined>, v.CheckAction<string, "url must be an https:// url">]>, never>;
    readonly nonce_endpoint: v.OptionalSchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.UrlAction<string, undefined>, v.CheckAction<string, "url must be an https:// url">]>, never>;
    readonly credential_response_encryption: v.OptionalSchema<v.LooseObjectSchema<{
        readonly alg_values_supported: v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly enc_values_supported: v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly encryption_required: v.BooleanSchema<undefined>;
    }, undefined>, never>;
    readonly batch_credential_issuance: v.OptionalSchema<v.LooseObjectSchema<{
        readonly batch_size: v.SchemaWithPipe<[v.NumberSchema<undefined>, v.IntegerAction<number, undefined>]>;
    }, undefined>, never>;
    readonly signed_metadata: v.OptionalSchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.RegexAction<string, "Not a valid compact jwt">]>, never>;
    readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
        readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly logo: v.OptionalSchema<v.LooseObjectSchema<{
            readonly uri: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly alt_text: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, never>;
    }, undefined>, undefined>, never>;
    readonly credential_configurations_supported: v.RecordSchema<v.StringSchema<undefined>, v.IntersectSchema<[v.VariantSchema<"format", [v.ObjectSchema<{
        readonly vct: v.StringSchema<undefined>;
        readonly format: v.LiteralSchema<"vc+sd-jwt", undefined>;
        readonly claims: v.OptionalSchema<v.LooseObjectSchema<{
            readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, never>;
            readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly display: v.OptionalSchema<v.LooseObjectSchema<{
                readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, never>;
        }, undefined>, never>;
        readonly order: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
    }, undefined>, v.ObjectSchema<{
        readonly format: v.LiteralSchema<"mso_mdoc", undefined>;
        readonly doctype: v.StringSchema<undefined>;
        readonly claims: v.OptionalSchema<v.LooseObjectSchema<{
            readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, never>;
            readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly display: v.OptionalSchema<v.LooseObjectSchema<{
                readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, never>;
        }, undefined>, never>;
        readonly order: v.OptionalSchema<v.ArraySchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.IncludesAction<string, "~", undefined>]>, undefined>, never>;
    }, undefined>, v.ObjectSchema<{
        readonly format: v.LiteralSchema<"jwt_vc_json-ld", undefined>;
        readonly credential_definition: v.LooseObjectSchema<{
            readonly '@context': v.ArraySchema<v.StringSchema<undefined>, undefined>;
            readonly type: v.ArraySchema<v.StringSchema<undefined>, undefined>;
            readonly credentialSubject: v.OptionalSchema<v.RecordSchema<v.StringSchema<undefined>, v.UnionSchema<[v.ArraySchema<v.AnySchema, undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>, v.LooseObjectSchema<{
                readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, false>;
                readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                    readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
                    readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
                }, undefined>, undefined>, never>;
            }, undefined>], undefined>, undefined>, never>;
        }, undefined>;
        readonly order: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
    }, undefined>, v.ObjectSchema<{
        readonly format: v.LiteralSchema<"ldp_vc", undefined>;
        readonly credential_definition: v.LooseObjectSchema<{
            readonly '@context': v.ArraySchema<v.StringSchema<undefined>, undefined>;
            readonly type: v.ArraySchema<v.StringSchema<undefined>, undefined>;
            readonly credentialSubject: v.OptionalSchema<v.RecordSchema<v.StringSchema<undefined>, v.UnionSchema<[v.ArraySchema<v.AnySchema, undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>, v.LooseObjectSchema<{
                readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, false>;
                readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                    readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
                    readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
                }, undefined>, undefined>, never>;
            }, undefined>], undefined>, undefined>, never>;
        }, undefined>;
        readonly order: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
    }, undefined>, v.ObjectSchema<{
        readonly format: v.LiteralSchema<"jwt_vc_json", undefined>;
        readonly credential_definition: v.LooseObjectSchema<{
            readonly type: v.ArraySchema<v.StringSchema<undefined>, undefined>;
            readonly credentialSubject: v.OptionalSchema<v.RecordSchema<v.StringSchema<undefined>, v.UnionSchema<[v.ArraySchema<v.AnySchema, undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>, v.LooseObjectSchema<{
                readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, false>;
                readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                    readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
                    readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
                }, undefined>, undefined>, never>;
            }, undefined>], undefined>, undefined>, never>;
        }, undefined>;
        readonly order: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
    }, undefined>, v.LooseObjectSchema<{
        readonly format: v.SchemaWithPipe<[v.StringSchema<undefined>, v.CheckAction<string, undefined>]>;
    }, undefined>], undefined>, v.LooseObjectSchema<{
        readonly format: v.StringSchema<undefined>;
        readonly scope: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly cryptographic_binding_methods_supported: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
        readonly credential_signing_alg_values_supported: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
        readonly proof_types_supported: v.OptionalSchema<v.RecordSchema<v.UnionSchema<[v.LiteralSchema<"jwt", undefined>, v.LiteralSchema<"attestation", undefined>, v.StringSchema<undefined>], undefined>, v.ObjectSchema<{
            readonly proof_signing_alg_values_supported: v.ArraySchema<v.StringSchema<undefined>, undefined>;
            readonly key_attestations_required: v.OptionalSchema<v.LooseObjectSchema<{
                readonly key_storage: v.OptionalSchema<v.ArraySchema<v.UnionSchema<[v.PicklistSchema<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"], undefined>, v.StringSchema<undefined>], undefined>, undefined>, never>;
                readonly user_authentication: v.OptionalSchema<v.ArraySchema<v.UnionSchema<[v.PicklistSchema<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"], undefined>, v.StringSchema<undefined>], undefined>, undefined>, never>;
            }, undefined>, never>;
        }, undefined>, undefined>, never>;
        readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
            readonly name: v.StringSchema<undefined>;
            readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly logo: v.OptionalSchema<v.LooseObjectSchema<{
                readonly uri: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly alt_text: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, never>;
            readonly description: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly background_color: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly background_image: v.OptionalSchema<v.LooseObjectSchema<{
                readonly uri: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, never>;
            readonly text_color: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, undefined>, never>;
    }, undefined>], undefined>, undefined>;
}, undefined>;
declare const vCredentialConfigurationSupportedDraft11To14: v.SchemaWithPipe<[v.LooseObjectSchema<{
    readonly id: v.OptionalSchema<v.StringSchema<undefined>, never>;
    readonly format: v.StringSchema<undefined>;
    readonly cryptographic_suites_supported: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
    readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
        readonly logo: v.OptionalSchema<v.LooseObjectSchema<{
            readonly url: v.OptionalSchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.UrlAction<string, undefined>]>, never>;
        }, undefined>, never>;
        readonly background_image: v.OptionalSchema<v.LooseObjectSchema<{
            readonly url: v.OptionalSchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.UrlAction<string, undefined>]>, never>;
        }, undefined>, never>;
    }, undefined>, undefined>, never>;
}, undefined>, v.TransformAction<{
    format: string;
    display?: ({
        logo?: ({
            url?: string | undefined;
        } & {
            [key: string]: unknown;
        }) | undefined;
        background_image?: ({
            url?: string | undefined;
        } & {
            [key: string]: unknown;
        }) | undefined;
    } & {
        [key: string]: unknown;
    })[] | undefined;
    id?: string | undefined;
    cryptographic_suites_supported?: string[] | undefined;
} & {
    [key: string]: unknown;
}, {
    display?: {
        background_image?: {
            uri: string;
        } | undefined;
        logo?: {
            uri: string;
        } | undefined;
    }[] | undefined;
    credential_signing_alg_values_supported?: string[] | undefined;
    format: string;
}>, v.VariantSchema<"format", [v.SchemaWithPipe<[v.LooseObjectSchema<{
    readonly order: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
    readonly format: v.LiteralSchema<"ldp_vc", undefined>;
    readonly '@context': v.ArraySchema<v.StringSchema<undefined>, undefined>;
    readonly types: v.ArraySchema<v.StringSchema<undefined>, undefined>;
    readonly credentialSubject: v.OptionalSchema<v.RecordSchema<v.StringSchema<undefined>, v.UnionSchema<[v.ArraySchema<v.AnySchema, undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>, v.LooseObjectSchema<{
        readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, false>;
        readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
            readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, undefined>, never>;
    }, undefined>], undefined>, undefined>, never>;
}, undefined>, v.TransformAction<{
    format: "ldp_vc";
    '@context': string[];
    types: string[];
    order?: string[] | undefined;
    credentialSubject?: {
        [x: string]: any[] | {
            [x: string]: any;
        } | ({
            mandatory: boolean;
            value_type?: string | undefined;
            display?: ({
                name?: string | undefined;
                locale?: string | undefined;
            } & {
                [key: string]: unknown;
            })[] | undefined;
        } & {
            [key: string]: unknown;
        });
    } | undefined;
} & {
    [key: string]: unknown;
}, {
    credential_definition: {
        credentialSubject?: {
            [x: string]: any[] | {
                [x: string]: any;
            } | ({
                mandatory: boolean;
                value_type?: string | undefined;
                display?: ({
                    name?: string | undefined;
                    locale?: string | undefined;
                } & {
                    [key: string]: unknown;
                })[] | undefined;
            } & {
                [key: string]: unknown;
            });
        } | undefined;
        '@context': string[];
        type: string[];
    };
    format: "ldp_vc";
    order?: string[] | undefined;
}>]>, v.SchemaWithPipe<[v.LooseObjectSchema<{
    readonly format: v.LiteralSchema<"jwt_vc_json", undefined>;
    readonly order: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
    readonly types: v.ArraySchema<v.StringSchema<undefined>, undefined>;
    readonly credentialSubject: v.OptionalSchema<v.RecordSchema<v.StringSchema<undefined>, v.UnionSchema<[v.ArraySchema<v.AnySchema, undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>, v.LooseObjectSchema<{
        readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, false>;
        readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
            readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, undefined>, never>;
    }, undefined>], undefined>, undefined>, never>;
}, undefined>, v.TransformAction<{
    format: "jwt_vc_json";
    types: string[];
    order?: string[] | undefined;
    credentialSubject?: {
        [x: string]: any[] | {
            [x: string]: any;
        } | ({
            mandatory: boolean;
            value_type?: string | undefined;
            display?: ({
                name?: string | undefined;
                locale?: string | undefined;
            } & {
                [key: string]: unknown;
            })[] | undefined;
        } & {
            [key: string]: unknown;
        });
    } | undefined;
} & {
    [key: string]: unknown;
}, {
    credential_definition: {
        credentialSubject?: {
            [x: string]: any[] | {
                [x: string]: any;
            } | ({
                mandatory: boolean;
                value_type?: string | undefined;
                display?: ({
                    name?: string | undefined;
                    locale?: string | undefined;
                } & {
                    [key: string]: unknown;
                })[] | undefined;
            } & {
                [key: string]: unknown;
            });
        } | undefined;
        type: string[];
    };
    format: "jwt_vc_json";
    order?: string[] | undefined;
}>]>, v.SchemaWithPipe<[v.LooseObjectSchema<{
    readonly order: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
    readonly format: v.LiteralSchema<"jwt_vc_json-ld", undefined>;
    readonly '@context': v.ArraySchema<v.StringSchema<undefined>, undefined>;
    readonly types: v.ArraySchema<v.StringSchema<undefined>, undefined>;
    readonly credentialSubject: v.OptionalSchema<v.RecordSchema<v.StringSchema<undefined>, v.UnionSchema<[v.ArraySchema<v.AnySchema, undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>, v.LooseObjectSchema<{
        readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, false>;
        readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
            readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, undefined>, never>;
    }, undefined>], undefined>, undefined>, never>;
}, undefined>, v.TransformAction<{
    format: "jwt_vc_json-ld";
    '@context': string[];
    types: string[];
    order?: string[] | undefined;
    credentialSubject?: {
        [x: string]: any[] | {
            [x: string]: any;
        } | ({
            mandatory: boolean;
            value_type?: string | undefined;
            display?: ({
                name?: string | undefined;
                locale?: string | undefined;
            } & {
                [key: string]: unknown;
            })[] | undefined;
        } & {
            [key: string]: unknown;
        });
    } | undefined;
} & {
    [key: string]: unknown;
}, {
    credential_definition: {
        credentialSubject?: {
            [x: string]: any[] | {
                [x: string]: any;
            } | ({
                mandatory: boolean;
                value_type?: string | undefined;
                display?: ({
                    name?: string | undefined;
                    locale?: string | undefined;
                } & {
                    [key: string]: unknown;
                })[] | undefined;
            } & {
                [key: string]: unknown;
            });
        } | undefined;
        '@context': string[];
        type: string[];
    };
    format: "jwt_vc_json-ld";
    order?: string[] | undefined;
}>]>, v.LooseObjectSchema<{
    readonly format: v.SchemaWithPipe<[v.StringSchema<undefined>, v.CheckAction<string, undefined>]>;
}, undefined>], undefined>, v.IntersectSchema<[v.VariantSchema<"format", [v.ObjectSchema<{
    readonly vct: v.StringSchema<undefined>;
    readonly format: v.LiteralSchema<"vc+sd-jwt", undefined>;
    readonly claims: v.OptionalSchema<v.LooseObjectSchema<{
        readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, never>;
        readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly display: v.OptionalSchema<v.LooseObjectSchema<{
            readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, never>;
    }, undefined>, never>;
    readonly order: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
}, undefined>, v.ObjectSchema<{
    readonly format: v.LiteralSchema<"mso_mdoc", undefined>;
    readonly doctype: v.StringSchema<undefined>;
    readonly claims: v.OptionalSchema<v.LooseObjectSchema<{
        readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, never>;
        readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly display: v.OptionalSchema<v.LooseObjectSchema<{
            readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, never>;
    }, undefined>, never>;
    readonly order: v.OptionalSchema<v.ArraySchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.IncludesAction<string, "~", undefined>]>, undefined>, never>;
}, undefined>, v.ObjectSchema<{
    readonly format: v.LiteralSchema<"jwt_vc_json-ld", undefined>;
    readonly credential_definition: v.LooseObjectSchema<{
        readonly '@context': v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly type: v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly credentialSubject: v.OptionalSchema<v.RecordSchema<v.StringSchema<undefined>, v.UnionSchema<[v.ArraySchema<v.AnySchema, undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>, v.LooseObjectSchema<{
            readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, false>;
            readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, undefined>, never>;
        }, undefined>], undefined>, undefined>, never>;
    }, undefined>;
    readonly order: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
}, undefined>, v.ObjectSchema<{
    readonly format: v.LiteralSchema<"ldp_vc", undefined>;
    readonly credential_definition: v.LooseObjectSchema<{
        readonly '@context': v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly type: v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly credentialSubject: v.OptionalSchema<v.RecordSchema<v.StringSchema<undefined>, v.UnionSchema<[v.ArraySchema<v.AnySchema, undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>, v.LooseObjectSchema<{
            readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, false>;
            readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, undefined>, never>;
        }, undefined>], undefined>, undefined>, never>;
    }, undefined>;
    readonly order: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
}, undefined>, v.ObjectSchema<{
    readonly format: v.LiteralSchema<"jwt_vc_json", undefined>;
    readonly credential_definition: v.LooseObjectSchema<{
        readonly type: v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly credentialSubject: v.OptionalSchema<v.RecordSchema<v.StringSchema<undefined>, v.UnionSchema<[v.ArraySchema<v.AnySchema, undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>, v.LooseObjectSchema<{
            readonly mandatory: v.OptionalSchema<v.BooleanSchema<undefined>, false>;
            readonly value_type: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                readonly name: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, undefined>, never>;
        }, undefined>], undefined>, undefined>, never>;
    }, undefined>;
    readonly order: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
}, undefined>, v.LooseObjectSchema<{
    readonly format: v.SchemaWithPipe<[v.StringSchema<undefined>, v.CheckAction<string, undefined>]>;
}, undefined>], undefined>, v.LooseObjectSchema<{
    readonly format: v.StringSchema<undefined>;
    readonly scope: v.OptionalSchema<v.StringSchema<undefined>, never>;
    readonly cryptographic_binding_methods_supported: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
    readonly credential_signing_alg_values_supported: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
    readonly proof_types_supported: v.OptionalSchema<v.RecordSchema<v.UnionSchema<[v.LiteralSchema<"jwt", undefined>, v.LiteralSchema<"attestation", undefined>, v.StringSchema<undefined>], undefined>, v.ObjectSchema<{
        readonly proof_signing_alg_values_supported: v.ArraySchema<v.StringSchema<undefined>, undefined>;
        readonly key_attestations_required: v.OptionalSchema<v.LooseObjectSchema<{
            readonly key_storage: v.OptionalSchema<v.ArraySchema<v.UnionSchema<[v.PicklistSchema<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"], undefined>, v.StringSchema<undefined>], undefined>, undefined>, never>;
            readonly user_authentication: v.OptionalSchema<v.ArraySchema<v.UnionSchema<[v.PicklistSchema<["iso_18045_high", "iso_18045_moderate", "iso_18045_enhanced-basic", "iso_18045_basic"], undefined>, v.StringSchema<undefined>], undefined>, undefined>, never>;
        }, undefined>, never>;
    }, undefined>, undefined>, never>;
    readonly display: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
        readonly name: v.StringSchema<undefined>;
        readonly locale: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly logo: v.OptionalSchema<v.LooseObjectSchema<{
            readonly uri: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly alt_text: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, never>;
        readonly description: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly background_color: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly background_image: v.OptionalSchema<v.LooseObjectSchema<{
            readonly uri: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, never>;
        readonly text_color: v.OptionalSchema<v.StringSchema<undefined>, never>;
    }, undefined>, undefined>, never>;
}, undefined>], undefined>]>;

interface IssuerMetadataResult {
    originalDraftVersion?: Oid4vciDraftVersion;
    credentialIssuer: CredentialIssuerMetadata;
    authorizationServers: AuthorizationServerMetadata[];
}

declare enum Oauth2ErrorCodes {
    ServerError = "server_error",
    InvalidTarget = "invalid_target",
    InvalidRequest = "invalid_request",
    InvalidToken = "invalid_token",
    InsufficientScope = "insufficient_scope",
    InvalidGrant = "invalid_grant",
    InvalidClient = "invalid_client",
    UnauthorizedClient = "unauthorized_client",
    UnsupportedGrantType = "unsupported_grant_type",
    InvalidScope = "invalid_scope",
    InvalidDpopProof = "invalid_dpop_proof",
    UseDpopNonce = "use_dpop_nonce",
    RedirectToWeb = "redirect_to_web",
    InvalidSession = "invalid_session",
    InsufficientAuthorization = "insufficient_authorization",
    InvalidCredentialRequest = "invalid_credential_request",
    CredentialRequestDenied = "credential_request_denied",
    UnsupportedCredentialType = "unsupported_credential_type",
    UnsupportedCredentialFormat = "unsupported_credential_format",
    InvalidProof = "invalid_proof",
    InvalidNonce = "invalid_nonce",
    InvalidEncryptionParameters = "invalid_encryption_parameters"
}

declare const vCredentialResponse: v.SchemaWithPipe<[v.LooseObjectSchema<{
    readonly credential: v.OptionalSchema<v.UnionSchema<[v.StringSchema<undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>], undefined>, never>;
    readonly credentials: v.OptionalSchema<v.ArraySchema<v.UnionSchema<[v.StringSchema<undefined>, v.RecordSchema<v.StringSchema<undefined>, v.AnySchema, undefined>], undefined>, undefined>, never>;
    readonly transaction_id: v.OptionalSchema<v.StringSchema<undefined>, never>;
    readonly c_nonce: v.OptionalSchema<v.StringSchema<undefined>, never>;
    readonly c_nonce_expires_in: v.OptionalSchema<v.SchemaWithPipe<[v.NumberSchema<undefined>, v.IntegerAction<number, undefined>]>, never>;
    readonly notification_id: v.OptionalSchema<v.StringSchema<undefined>, never>;
}, undefined>, v.CheckAction<{
    c_nonce?: string | undefined;
    c_nonce_expires_in?: number | undefined;
    credentials?: (string | {
        [x: string]: any;
    })[] | undefined;
    credential?: string | {
        [x: string]: any;
    } | undefined;
    transaction_id?: string | undefined;
    notification_id?: string | undefined;
} & {
    [key: string]: unknown;
}, "Exactly one of 'credential', 'credentials', or 'transaction_id' MUST be defined.">]>;
type CredentialResponse = v.InferOutput<typeof vCredentialResponse>;
declare const vCredentialErrorResponse: v.LooseObjectSchema<{
    readonly c_nonce: v.OptionalSchema<v.StringSchema<undefined>, never>;
    readonly c_nonce_expires_in: v.OptionalSchema<v.SchemaWithPipe<[v.NumberSchema<undefined>, v.IntegerAction<number, undefined>]>, never>;
    readonly error: v.UnionSchema<[v.EnumSchema<typeof Oauth2ErrorCodes, undefined>, v.StringSchema<undefined>], undefined>;
    readonly error_description: v.OptionalSchema<v.StringSchema<undefined>, never>;
    readonly error_uri: v.OptionalSchema<v.StringSchema<undefined>, never>;
}, undefined>;
type CredentialErrorResponse = v.InferOutput<typeof vCredentialErrorResponse>;

interface RetrieveCredentialsBaseOptions {
    /**
     * Metadata of the credential issuer and authorization servers.
     */
    issuerMetadata: IssuerMetadataResult;
    /**
     * Callback used in retrieve credentials endpoints
     */
    callbacks: Pick<CallbackContext, 'fetch' | 'generateRandom' | 'hash' | 'signJwt'>;
    /**
     * Access token authorized to retrieve the credential(s)
     */
    accessToken: string;
    /**
     * DPoP options
     */
    dpop?: RequestDpopOptions;
}
interface RetrieveCredentialsWithFormatOptions extends RetrieveCredentialsBaseOptions {
    /**
     * Additional payload to include in the credential request.
     */
    additionalRequestPayload?: Record<string, unknown>;
    /**
     * The format specific payload. Needs to at least include the `format` and other params
     * are determined by the format itself
     */
    formatPayload: CredentialRequestWithFormats;
    proof?: CredentialRequestProof;
    proofs?: CredentialRequestProofs;
}
interface RetrieveCredentialsResponseOk extends ResourceRequestResponseOk {
    /**
     * The successfull validated (in structure, not the actual contents are validated) credential response payload
     */
    credentialResponse: CredentialResponse;
}
interface RetrieveCredentialsResponseNotOk extends ResourceRequestResponseNotOk {
    /**
     * If this is defined it means the response itself was succesfull but the validation of the
     * credential response data structure failed
     */
    credentialResponseResult?: SafeParseResult<typeof vCredentialResponse>;
    /**
     * If this is defined it means the response was JSON and we tried to parse it as
     * a credential error response. It may be successfull or it may not be.
     */
    credentialErrorResponseResult?: SafeParseResult<typeof vCredentialErrorResponse>;
}

interface GetCredentialConfigurationsMatchingRequestFormatOptions {
    requestFormat: CredentialRequestFormatSpecific;
    credentialConfigurations: CredentialConfigurationsSupported;
}
declare function getCredentialConfigurationsMatchingRequestFormat({ requestFormat, credentialConfigurations, }: GetCredentialConfigurationsMatchingRequestFormatOptions): CredentialConfigurationsSupportedWithFormats;

interface Oid4vciErrorOptions {
    cause?: unknown;
}
declare class Oid4vciError extends Error {
    readonly cause?: unknown;
    constructor(message?: string, options?: Oid4vciErrorOptions);
}

declare class Oid4vciRetrieveCredentialsError extends Oid4vciError {
    response: RetrieveCredentialsResponseNotOk;
    constructor(message: string, response: RetrieveCredentialsResponseNotOk, responseText: string);
}

declare const vNotificationEvent: v.PicklistSchema<["credential_accepted", "credential_failure", "credential_deleted"], undefined>;
type NotificationEvent = v.InferOutput<typeof vNotificationEvent>;
declare const vNotificationErrorResponse: v.LooseObjectSchema<{
    readonly error: v.PicklistSchema<["invalid_notification_id", "invalid_notification_request"], undefined>;
}, undefined>;
type NotificationErrorResponse = v.InferOutput<typeof vNotificationErrorResponse>;

interface SendNotifcationOptions {
    notification: {
        /**
         * Notification id, as returned in the credential response
         */
        notificationId: string;
        /**
         * The notification
         */
        event: NotificationEvent;
        /**
         * Humand readable desription of the event
         */
        eventDescription?: string;
    };
    /**
     * Metadata of the credential issuer and authorization servers.
     */
    issuerMetadata: IssuerMetadataResult;
    /**
     * Callback used in notification endpoint
     */
    callbacks: Pick<CallbackContext, 'fetch' | 'generateRandom' | 'hash' | 'signJwt'>;
    /**
     * Access token authorized to retrieve the credential(s)
     */
    accessToken: string;
    /**
     * DPoP options
     */
    dpop?: RequestDpopOptions;
    /**
     * Additional payload to include in the notification request.
     */
    additionalRequestPayload?: Record<string, unknown>;
}
type SendNotificationResponseOk = ResourceRequestResponseOk;
interface SendNotificationResponseNotOk extends ResourceRequestResponseNotOk {
    /**
     * If this is defined it means the response was JSON and we tried to parse it as
     * a notification error response. It may be successfull or it may not be.
     */
    notificationErrorResponseResult?: v.SafeParseResult<typeof vNotificationErrorResponse>;
}

declare class Oid4vciSendNotificationError extends Oid4vciError {
    response: SendNotificationResponseNotOk;
    constructor(message: string, response: SendNotificationResponseNotOk);
}

declare const vNonceResponse: v.LooseObjectSchema<{
    readonly c_nonce: v.StringSchema<undefined>;
    readonly c_nonce_expires_in: v.OptionalSchema<v.SchemaWithPipe<[v.NumberSchema<undefined>, v.IntegerAction<number, undefined>]>, never>;
}, undefined>;
type NonceResponse = v.InferOutput<typeof vNonceResponse>;

declare const vJwtProofTypeIdentifier: v.LiteralSchema<"jwt", undefined>;
type JwtProofTypeIdentifier = v.InferOutput<typeof vJwtProofTypeIdentifier>;
declare const vCredentialRequestJwtProofTypeHeader: v.SchemaWithPipe<[v.LooseObjectSchema<{
    readonly key_attestation: v.OptionalSchema<v.SchemaWithPipe<[v.StringSchema<undefined>, v.RegexAction<string, "Not a valid compact jwt">]>, never>;
    readonly typ: v.LiteralSchema<"openid4vci-proof+jwt", undefined>;
    readonly alg: v.SchemaWithPipe<[v.StringSchema<undefined>, v.CheckAction<string, "alg value may not be 'none'">]>;
    readonly kid: v.OptionalSchema<v.StringSchema<undefined>, never>;
    readonly jwk: v.OptionalSchema<v.LooseObjectSchema<{
        readonly kty: v.StringSchema<undefined>;
        readonly crv: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly x: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly y: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly e: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly n: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly alg: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly d: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly dp: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly dq: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly ext: v.OptionalSchema<v.BooleanSchema<undefined>, never>;
        readonly k: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly key_ops: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly kid: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly oth: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
            readonly d: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly r: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly t: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, undefined>, never>;
        readonly p: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly q: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly qi: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly use: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly x5c: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly x5t: v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly 'x5t#S256': v.OptionalSchema<v.StringSchema<undefined>, never>;
        readonly x5u: v.OptionalSchema<v.StringSchema<undefined>, never>;
    }, undefined>, never>;
    readonly x5c: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
    readonly trust_chain: v.OptionalSchema<v.ArraySchema<v.StringSchema<undefined>, undefined>, never>;
}, undefined>, v.CheckAction<{
    alg: string;
    typ: "openid4vci-proof+jwt";
    kid?: string | undefined;
    x5c?: string[] | undefined;
    jwk?: ({
        kty: string;
        crv?: string | undefined;
        x?: string | undefined;
        y?: string | undefined;
        e?: string | undefined;
        n?: string | undefined;
        alg?: string | undefined;
        d?: string | undefined;
        dp?: string | undefined;
        dq?: string | undefined;
        ext?: boolean | undefined;
        k?: string | undefined;
        key_ops?: string | undefined;
        kid?: string | undefined;
        oth?: ({
            d?: string | undefined;
            r?: string | undefined;
            t?: string | undefined;
        } & {
            [key: string]: unknown;
        })[] | undefined;
        p?: string | undefined;
        q?: string | undefined;
        qi?: string | undefined;
        use?: string | undefined;
        x5c?: string | undefined;
        x5t?: string | undefined;
        'x5t#S256'?: string | undefined;
        x5u?: string | undefined;
    } & {
        [key: string]: unknown;
    }) | undefined;
    trust_chain?: string[] | undefined;
    key_attestation?: string | undefined;
} & {
    [key: string]: unknown;
}, "Both 'jwk' and 'kid' are defined. Only one is allowed">, v.CheckAction<{
    alg: string;
    typ: "openid4vci-proof+jwt";
    kid?: string | undefined;
    x5c?: string[] | undefined;
    jwk?: ({
        kty: string;
        crv?: string | undefined;
        x?: string | undefined;
        y?: string | undefined;
        e?: string | undefined;
        n?: string | undefined;
        alg?: string | undefined;
        d?: string | undefined;
        dp?: string | undefined;
        dq?: string | undefined;
        ext?: boolean | undefined;
        k?: string | undefined;
        key_ops?: string | undefined;
        kid?: string | undefined;
        oth?: ({
            d?: string | undefined;
            r?: string | undefined;
            t?: string | undefined;
        } & {
            [key: string]: unknown;
        })[] | undefined;
        p?: string | undefined;
        q?: string | undefined;
        qi?: string | undefined;
        use?: string | undefined;
        x5c?: string | undefined;
        x5t?: string | undefined;
        'x5t#S256'?: string | undefined;
        x5u?: string | undefined;
    } & {
        [key: string]: unknown;
    }) | undefined;
    trust_chain?: string[] | undefined;
    key_attestation?: string | undefined;
} & {
    [key: string]: unknown;
}, "When 'trust_chain' is provided, 'kid' is required">]>;
type CredentialRequestJwtProofTypeHeader = v.InferOutput<typeof vCredentialRequestJwtProofTypeHeader>;
declare const vCredentialRequestJwtProofTypePayload: v.LooseObjectSchema<{
    readonly aud: v.SchemaWithPipe<[v.StringSchema<undefined>, v.UrlAction<string, undefined>, v.CheckAction<string, "url must be an https:// url">]>;
    readonly iat: v.SchemaWithPipe<[v.NumberSchema<undefined>, v.IntegerAction<number, undefined>]>;
    readonly iss: v.OptionalSchema<v.StringSchema<undefined>, never>;
    readonly exp: v.OptionalSchema<v.SchemaWithPipe<[v.NumberSchema<undefined>, v.IntegerAction<number, undefined>]>, never>;
    readonly nbf: v.OptionalSchema<v.SchemaWithPipe<[v.NumberSchema<undefined>, v.IntegerAction<number, undefined>]>, never>;
    readonly nonce: v.OptionalSchema<v.StringSchema<undefined>, never>;
    readonly jti: v.OptionalSchema<v.StringSchema<undefined>, never>;
    readonly cnf: v.OptionalSchema<v.LooseObjectSchema<{
        readonly jwk: v.OptionalSchema<v.LooseObjectSchema<{
            readonly kty: v.StringSchema<undefined>;
            readonly crv: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly x: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly y: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly e: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly n: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly alg: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly d: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly dp: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly dq: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly ext: v.OptionalSchema<v.BooleanSchema<undefined>, never>;
            readonly k: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly key_ops: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly kid: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly oth: v.OptionalSchema<v.ArraySchema<v.LooseObjectSchema<{
                readonly d: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly r: v.OptionalSchema<v.StringSchema<undefined>, never>;
                readonly t: v.OptionalSchema<v.StringSchema<undefined>, never>;
            }, undefined>, undefined>, never>;
            readonly p: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly q: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly qi: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly use: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly x5c: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly x5t: v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly 'x5t#S256': v.OptionalSchema<v.StringSchema<undefined>, never>;
            readonly x5u: v.OptionalSchema<v.StringSchema<undefined>, never>;
        }, undefined>, never>;
        readonly jkt: v.OptionalSchema<v.StringSchema<undefined>, never>;
    }, undefined>, never>;
    readonly status: v.OptionalSchema<v.LooseObjectSchema<{}, undefined>, never>;
}, undefined>;
type CredentialRequestJwtProofTypePayload = v.InferOutput<typeof vCredentialRequestJwtProofTypePayload>;

type KeyAttestationJwtUse = 'proof_type.jwt' | 'proof_type.attestation';

declare const vAttestationProofTypeIdentifier: v.LiteralSchema<"attestation", undefined>;
type AttestationProofTypeIdentifier = v.InferOutput<typeof vAttestationProofTypeIdentifier>;

type ProofTypeIdentifier = JwtProofTypeIdentifier | AttestationProofTypeIdentifier;

declare const vMsoMdocFormatIdentifier: v.LiteralSchema<"mso_mdoc", undefined>;
type MsoMdocFormatIdentifier = v.InferOutput<typeof vMsoMdocFormatIdentifier>;

declare const vSdJwtVcFormatIdentifier: v.LiteralSchema<"vc+sd-jwt", undefined>;
type SdJwtVcFormatIdentifier = v.InferOutput<typeof vSdJwtVcFormatIdentifier>;

declare const vJwtVcJsonFormatIdentifier: v.LiteralSchema<"jwt_vc_json", undefined>;
type JwtVcJsonFormatIdentifier = v.InferOutput<typeof vJwtVcJsonFormatIdentifier>;

declare const vJwtVcJsonLdFormatIdentifier: v.LiteralSchema<"jwt_vc_json-ld", undefined>;
type JwtVcJsonLdFormatIdentifier = v.InferOutput<typeof vJwtVcJsonLdFormatIdentifier>;

declare const vLdpVcFormatIdentifier: v.LiteralSchema<"ldp_vc", undefined>;
type LdpVcFormatIdentifier = v.InferOutput<typeof vLdpVcFormatIdentifier>;

type CredentialFormatIdentifier = MsoMdocFormatIdentifier | SdJwtVcFormatIdentifier | LdpVcFormatIdentifier | JwtVcJsonLdFormatIdentifier | JwtVcJsonFormatIdentifier;

interface ExtractScopesForCredentialConfigurationIdsOptions {
    /**
     * The credential configuration ids to extract the scope from
     */
    credentialConfigurationIds: string[];
    /**
     * Wheter to throw an error if the correspdong credential configuration
     * for a provided credential configuration id has no scope.
     *
     * @default false
     */
    throwOnConfigurationWithoutScope?: boolean;
    /**
     * The issuer metadata
     */
    issuerMetadata: IssuerMetadataResult;
}
declare function extractScopesForCredentialConfigurationIds(options: ExtractScopesForCredentialConfigurationIdsOptions): string[] | undefined;
/**
 * Transforms draft 11 credentials supported syntax to credential configurations supported
 *
 * @throws if a credentials supported entry without id is passed
 * @throws if a credentials supported entry with invalid structure or format specific properties is passed
 */
declare function credentialsSupportedToCredentialConfigurationsSupported(credentialsSupported: Array<v.InferInput<typeof vCredentialConfigurationSupportedDraft11To14>>): CredentialConfigurationsSupported;

interface CreateCredentialRequestJwtProofOptions {
    /**
     * Nonce to use in the jwt. Should be derived from the c_nonce
     */
    nonce?: string;
    /**
     * The credential issuer identifier
     */
    credentialIssuer: string;
    /**
     * The date when the token was issued. If not provided the current time will be used.
     */
    issuedAt?: Date;
    /**
     * The client id of the wallet requesting the credential. Should not be included when using
     * the pre-authorized code flow
     */
    clientId?: string;
    /**
     * Key attestation jwt that the proof should based on. In this case it is required that the `signer` uses
     * a key from the `attested_keys` in the key attestation jwt payload.
     */
    keyAttestationJwt?: string;
    signer: JwtSigner;
    callbacks: Pick<CallbackContext, 'signJwt' | 'hash'>;
}
interface VerifyCredentialRequestJwtProofOptions {
    /**
     * The proof jwt
     */
    jwt: string;
    /**
     * Expected nonce. Should be a c_nonce previously shared with the wallet
     */
    expectedNonce?: string;
    /**
     * Date at which the nonce will expire
     */
    nonceExpiresAt?: Date;
    /**
     * The credential issuer identifier, will be matched against the `aud` claim.
     */
    credentialIssuer: string;
    /**
     * The client id of the wallet requesting the credential, if available.
     */
    clientId?: string;
    /**
     * Current time, if not provided a new date instance will be created
     */
    now?: Date;
    /**
     * Callbacks required for the jwt verification.
     *
     * Will be used for the jwt proof, and optionally a `key_attestation` in the jwt proof header.
     */
    callbacks: Pick<CallbackContext, 'verifyJwt' | 'hash'>;
}

interface RequestNonceOptions {
    issuerMetadata: IssuerMetadataResult;
    /**
     * Custom fetch implementation to use
     */
    fetch?: Fetch;
}
interface CreateNonceResponseOptions {
    cNonce: string;
    cNonceExpiresIn?: number;
    /**
     * Additional payload to include in the nonce response.
     *
     * Will be applied after default params to allow extension so be cautious
     */
    additionalPayload?: Record<string, unknown>;
}

declare enum AuthorizationFlow {
    Oauth2Redirect = "Oauth2Redirect",
    PresentationDuringIssuance = "PresentationDuringIssuance"
}
interface Oid4vciClientOptions {
    /**
     * Callbacks required for the oid4vc client
     */
    callbacks: Omit<CallbackContext, 'verifyJwt' | 'clientAuthentication'>;
}
declare class Oid4vciClient {
    private options;
    private oauth2Client;
    constructor(options: Oid4vciClientOptions);
    getKnownCredentialConfigurationsSupported(credentialIssuerMetadata: CredentialIssuerMetadata): CredentialConfigurationsSupportedWithFormats;
    /**
     * Resolve a credential offer into a credential offer object, handling both
     * 'credential_offer' and 'credential_offer_uri' params.
     */
    resolveCredentialOffer(credentialOffer: string): Promise<CredentialOfferObject>;
    resolveIssuerMetadata(credentialIssuer: string): Promise<IssuerMetadataResult>;
    /**
     * Retrieve an authorization code for a presentation during issuance session
     *
     * This can only be called if an authorization challenge was performed before and returned a
     * `presentation` paramater along with an `auth_session`. If the presentation response included
     * an `presentation_during_issuance_session` parameter it MUST be included in this request as well.
     */
    retrieveAuthorizationCodeUsingPresentation(options: {
        /**
         * Auth session as returned by `{@link Oid4vciClient.initiateAuthorization}
         */
        authSession: string;
        /**
         * Presentation during issuance session, obtained from the RP after submitting
         * openid4vp authorization response
         */
        presentationDuringIssuanceSession?: string;
        credentialOffer: CredentialOfferObject;
        issuerMetadata: IssuerMetadataResult;
        dpop?: RequestDpopOptions;
    }): Promise<{
        authorizationChallengeResponse: {
            authorization_code: string;
        } & {
            [key: string]: unknown;
        };
        dpop: {
            nonce: any;
            signer: _openid4vc_oauth2.JwtSignerJwk;
        } | undefined;
    }>;
    /**
     * Initiates authorization for credential issuance. It handles the following cases:
     * - Authorization Challenge
     * - Pushed Authorization Request
     * - Regular Authorization url
     *
     * In case the authorization challenge request returns an error with `insufficient_authorization`
     * with a `presentation` field it means the authorization server expects presentation of credentials
     * before issuance of crednetials. If this is the case, the value in `presentation` should be treated
     * as an openid4vp authorization request and submitted to the verifier. Once the presentation response
     * has been submitted, the RP will respnosd with a `presentation_during_issuance_session` parameter.
     * Together with the `auth_session` parameter returned in this call you can retrieve an `authorization_code`
     * using
     */
    initiateAuthorization(options: Omit<CreateAuthorizationRequestUrlOptions, 'callbacks' | 'authorizationServerMetadata'> & {
        credentialOffer: CredentialOfferObject;
        issuerMetadata: IssuerMetadataResult;
    }): Promise<{
        authorizationFlow: AuthorizationFlow.PresentationDuringIssuance;
        oid4vpRequestUrl: string;
        authSession: string;
        authorizationServer: string;
    } | {
        authorizationFlow: AuthorizationFlow.Oauth2Redirect;
        authorizationRequestUrl: string;
        authorizationServer: string;
        pkce?: CreatePkceReturn;
    }>;
    /**
     * Convenience method around {@link Oauth2Client.createAuthorizationRequestUrl}
     * but specifically focused on a credential offer
     */
    createAuthorizationRequestUrlFromOffer(options: Omit<CreateAuthorizationRequestUrlOptions, 'callbacks' | 'authorizationServerMetadata'> & {
        credentialOffer: CredentialOfferObject;
        issuerMetadata: IssuerMetadataResult;
    }): Promise<{
        authorizationRequestUrl: string;
        pkce: CreatePkceReturn | undefined;
        dpop: RequestDpopOptions | undefined;
        authorizationServer: string;
    }>;
    /**
     * Convenience method around {@link Oauth2Client.retrievePreAuthorizedCodeAccessToken}
     * but specifically focused on a credential offer
     */
    retrievePreAuthorizedCodeAccessTokenFromOffer({ credentialOffer, issuerMetadata, additionalRequestPayload, txCode, dpop, clientAttestation, }: Omit<RetrievePreAuthorizedCodeAccessTokenOptions, 'callbacks' | 'authorizationServerMetadata' | 'preAuthorizedCode' | 'resource'> & {
        credentialOffer: CredentialOfferObject;
        issuerMetadata: IssuerMetadataResult;
    }): Promise<{
        authorizationServer: string;
        accessTokenResponse: _openid4vc_oauth2.AccessTokenResponse;
        dpop?: RequestDpopOptions;
    }>;
    /**
     * Convenience method around {@link Oauth2Client.retrieveAuthorizationCodeAccessTokenFrom}
     * but specifically focused on a credential offer
     */
    retrieveAuthorizationCodeAccessTokenFromOffer({ issuerMetadata, additionalRequestPayload, credentialOffer, authorizationCode, pkceCodeVerifier, redirectUri, dpop, clientAttestation, }: Omit<RetrieveAuthorizationCodeAccessTokenOptions, 'authorizationServerMetadata' | 'callbacks'> & {
        credentialOffer: CredentialOfferObject;
        issuerMetadata: IssuerMetadataResult;
    }): Promise<{
        authorizationServer: string;
        accessTokenResponse: _openid4vc_oauth2.AccessTokenResponse;
        dpop?: RequestDpopOptions;
    }>;
    /**
     * Request a nonce to be used in credential request proofs from the `nonce_endpoint`
     *
     * @throws Oid4vciError - if no `nonce_endpoint` is configured in the issuer metadata
     * @thrwos InvalidFetchResponseError - if the nonce endpoint did not return a succesfull response
     * @throws ValidationError - if validating the nonce response failed
     */
    requestNonce(options: Pick<RequestNonceOptions, 'issuerMetadata'>): Promise<{
        c_nonce: string;
        c_nonce_expires_in?: number | undefined;
    } & {
        [key: string]: unknown;
    }>;
    /**
     * Creates the jwt proof payload and header to be included in a credential request.
     */
    createCredentialRequestJwtProof(options: Pick<CreateCredentialRequestJwtProofOptions, 'signer' | 'nonce' | 'issuedAt' | 'clientId' | 'keyAttestationJwt'> & {
        issuerMetadata: IssuerMetadataResult;
        credentialConfigurationId: string;
    }): Promise<{
        jwt: string;
    }>;
    /**
     * @throws Oid4vciRetrieveCredentialsError - if an unsuccesfull response or the respnose couldn't be parsed as credential response
     * @throws ValidationError - if validation of the credential request failed
     * @throws Oid4vciError - if the `credentialConfigurationId` couldn't be found, or if the the format specific request couldn't be constructed
     */
    retrieveCredentials({ issuerMetadata, proof, proofs, credentialConfigurationId, additionalRequestPayload, accessToken, dpop, }: Pick<RetrieveCredentialsWithFormatOptions, 'accessToken' | 'additionalRequestPayload' | 'issuerMetadata' | 'proof' | 'proofs' | 'dpop'> & {
        credentialConfigurationId: string;
    }): Promise<RetrieveCredentialsResponseOk>;
    /**
     * @throws Oid4vciSendNotificationError - if an unsuccesfull response
     * @throws ValidationError - if validation of the notification request failed
     */
    sendNotification({ issuerMetadata, notification, additionalRequestPayload, accessToken, dpop, }: Pick<SendNotifcationOptions, 'accessToken' | 'additionalRequestPayload' | 'issuerMetadata' | 'dpop' | 'notification'>): Promise<_openid4vc_oauth2.ResourceRequestResponseOk>;
}

interface CreateCredentialOfferGrantsOptions {
    [preAuthorizedCodeGrantIdentifier]?: Partial<CredentialOfferPreAuthorizedCodeGrant>;
    [authorizationCodeGrantIdentifier]?: CredenialOfferAuthorizationCodeGrant;
    [key: string]: unknown;
}
interface CreateCredentialOfferOptions {
    issuerMetadata: IssuerMetadataResult;
    /**
     * The credential configuration ids to be offered
     */
    credentialConfigurationIds: string[];
    /**
     * Grants to include in the credential offer
     */
    grants: CreateCredentialOfferGrantsOptions;
    /**
     * Additional payload to include in the body of the credential offer. Will be applied
     * after the other fields, allowing to override common properties, so be cautious.
     */
    additionalPayload?: Record<string, unknown>;
    /**
     * If provided the encoded credential offer will use the `credential_offer_uri` parameter
     * instaed of directly adding the `credential_offer`. Requires hosting of the `credential_offer_uri`
     */
    credentialOfferUri?: string;
    /**
     * The scheme to use for the credential offer.
     *
     * @default `openid-credential-offer://`
     */
    credentialOfferScheme?: string;
    /**
     * Callbacks used to create credential offer
     */
    callbacks: Pick<CallbackContext, 'generateRandom'>;
}

interface CreateCredentialResponseOptions {
    credentialRequest: ParseCredentialRequestReturn;
    credential?: CredentialResponse['credential'];
    credentials?: CredentialResponse['credentials'];
    cNonce?: string;
    cNonceExpiresInSeconds?: number;
    notificationId?: string;
    /**
     * Additional payload to include in the credential response
     */
    additionalPayload?: Record<string, unknown>;
}

interface VerifyKeyAttestationJwtOptions {
    /**
     * The compact key attestation jwt
     */
    keyAttestationJwt: string;
    /**
     * Expected nonce. If the key attestation is used directly as proof this should be provided.
     */
    expectedNonce?: string;
    /**
     * Date at which the nonce will expire
     */
    nonceExpiresAt?: Date;
    /**
     * The intended use of the key attestation. Based on this additional validation
     * is performed.
     *
     * - `proof_type.jwt` -> `exp` MUST be set
     * - `proof_type.attestation` -> `nonce` MUST be set
     */
    use?: KeyAttestationJwtUse;
    /**
     * Current time, if not provided a new date instance will be created
     */
    now?: Date;
    /**
     * Callbacks required for the key attestation jwt verification
     */
    callbacks: Pick<CallbackContext, 'verifyJwt'>;
}

interface VerifyCredentialRequestAttestationProofOptions extends Omit<VerifyKeyAttestationJwtOptions, 'use'> {
}

interface Oid4vciIssuerOptions {
    /**
     * Callbacks required for the oid4vc issuer
     */
    callbacks: CallbackContext;
}
declare class Oid4vciIssuer {
    private options;
    constructor(options: Oid4vciIssuerOptions);
    getCredentialIssuerMetadataDraft11(credentialIssuerMetadata: CredentialIssuerMetadata): {
        credential_issuer: string;
        credential_configurations_supported: {
            [x: string]: ({
                format: "jwt_vc_json";
                credential_definition: {
                    type: string[];
                    credentialSubject?: {
                        [x: string]: any[] | {
                            [x: string]: any;
                        } | ({
                            mandatory: boolean;
                            value_type?: string | undefined;
                            display?: ({
                                name?: string | undefined;
                                locale?: string | undefined;
                            } & {
                                [key: string]: unknown;
                            })[] | undefined;
                        } & {
                            [key: string]: unknown;
                        });
                    } | undefined;
                } & {
                    [key: string]: unknown;
                };
                order?: string[] | undefined;
            } | {
                format: "jwt_vc_json-ld";
                credential_definition: {
                    type: string[];
                    '@context': string[];
                    credentialSubject?: {
                        [x: string]: any[] | {
                            [x: string]: any;
                        } | ({
                            mandatory: boolean;
                            value_type?: string | undefined;
                            display?: ({
                                name?: string | undefined;
                                locale?: string | undefined;
                            } & {
                                [key: string]: unknown;
                            })[] | undefined;
                        } & {
                            [key: string]: unknown;
                        });
                    } | undefined;
                } & {
                    [key: string]: unknown;
                };
                order?: string[] | undefined;
            } | {
                format: "ldp_vc";
                credential_definition: {
                    type: string[];
                    '@context': string[];
                    credentialSubject?: {
                        [x: string]: any[] | {
                            [x: string]: any;
                        } | ({
                            mandatory: boolean;
                            value_type?: string | undefined;
                            display?: ({
                                name?: string | undefined;
                                locale?: string | undefined;
                            } & {
                                [key: string]: unknown;
                            })[] | undefined;
                        } & {
                            [key: string]: unknown;
                        });
                    } | undefined;
                } & {
                    [key: string]: unknown;
                };
                order?: string[] | undefined;
            } | {
                format: "mso_mdoc";
                doctype: string;
                claims?: ({
                    mandatory?: boolean | undefined;
                    value_type?: string | undefined;
                    display?: ({
                        name?: string | undefined;
                        locale?: string | undefined;
                    } & {
                        [key: string]: unknown;
                    }) | undefined;
                } & {
                    [key: string]: unknown;
                }) | undefined;
                order?: string[] | undefined;
            } | {
                format: "vc+sd-jwt";
                vct: string;
                claims?: ({
                    mandatory?: boolean | undefined;
                    value_type?: string | undefined;
                    display?: ({
                        name?: string | undefined;
                        locale?: string | undefined;
                    } & {
                        [key: string]: unknown;
                    }) | undefined;
                } & {
                    [key: string]: unknown;
                }) | undefined;
                order?: string[] | undefined;
            } | ({
                format: string;
            } & {
                [key: string]: unknown;
            })) & {
                format: string;
                scope?: string | undefined;
                display?: ({
                    name: string;
                    description?: string | undefined;
                    locale?: string | undefined;
                    logo?: ({
                        uri?: string | undefined;
                        alt_text?: string | undefined;
                    } & {
                        [key: string]: unknown;
                    }) | undefined;
                    background_color?: string | undefined;
                    background_image?: ({
                        uri?: string | undefined;
                    } & {
                        [key: string]: unknown;
                    }) | undefined;
                    text_color?: string | undefined;
                } & {
                    [key: string]: unknown;
                })[] | undefined;
                cryptographic_binding_methods_supported?: string[] | undefined;
                credential_signing_alg_values_supported?: string[] | undefined;
                proof_types_supported?: {
                    [x: string]: {
                        proof_signing_alg_values_supported: string[];
                        key_attestations_required?: ({
                            user_authentication?: string[] | undefined;
                            key_storage?: string[] | undefined;
                        } & {
                            [key: string]: unknown;
                        }) | undefined;
                    };
                } | undefined;
            } & {
                [key: string]: unknown;
            };
        };
        credential_endpoint: string;
        display?: ({
            name?: string | undefined;
            locale?: string | undefined;
            logo?: ({
                uri?: string | undefined;
                alt_text?: string | undefined;
            } & {
                [key: string]: unknown;
            }) | undefined;
        } & {
            [key: string]: unknown;
        })[] | undefined;
        credential_response_encryption?: ({
            alg_values_supported: string[];
            enc_values_supported: string[];
            encryption_required: boolean;
        } & {
            [key: string]: unknown;
        }) | undefined;
        authorization_servers?: string[] | undefined;
        deferred_credential_endpoint?: string | undefined;
        notification_endpoint?: string | undefined;
        nonce_endpoint?: string | undefined;
        batch_credential_issuance?: ({
            batch_size: number;
        } & {
            [key: string]: unknown;
        }) | undefined;
        signed_metadata?: string | undefined;
    } & {
        [key: string]: unknown;
    } & {
        credentials_supported: ({
            id: string;
        } & {
            [key: string]: unknown;
        } & (({
            format: "jwt_vc_json";
            types: string[];
            order?: string[] | undefined;
            credentialSubject?: {
                [x: string]: any[] | {
                    [x: string]: any;
                } | ({
                    mandatory: boolean;
                    value_type?: string | undefined;
                    display?: ({
                        name?: string | undefined;
                        locale?: string | undefined;
                    } & {
                        [key: string]: unknown;
                    })[] | undefined;
                } & {
                    [key: string]: unknown;
                });
            } | undefined;
        } & {
            [key: string]: unknown;
        }) | ({
            format: "jwt_vc_json-ld";
            '@context': string[];
            types: string[];
            order?: string[] | undefined;
            credentialSubject?: {
                [x: string]: any[] | {
                    [x: string]: any;
                } | ({
                    mandatory: boolean;
                    value_type?: string | undefined;
                    display?: ({
                        name?: string | undefined;
                        locale?: string | undefined;
                    } & {
                        [key: string]: unknown;
                    })[] | undefined;
                } & {
                    [key: string]: unknown;
                });
            } | undefined;
        } & {
            [key: string]: unknown;
        }) | ({
            format: "ldp_vc";
            '@context': string[];
            types: string[];
            order?: string[] | undefined;
            credentialSubject?: {
                [x: string]: any[] | {
                    [x: string]: any;
                } | ({
                    mandatory: boolean;
                    value_type?: string | undefined;
                    display?: ({
                        name?: string | undefined;
                        locale?: string | undefined;
                    } & {
                        [key: string]: unknown;
                    })[] | undefined;
                } & {
                    [key: string]: unknown;
                });
            } | undefined;
        } & {
            [key: string]: unknown;
        }) | ({
            format: string;
        } & {
            [key: string]: unknown;
        })))[];
    };
    getKnownCredentialConfigurationsSupported(credentialIssuerMetadata: CredentialIssuerMetadata): CredentialConfigurationsSupportedWithFormats;
    /**
     * Create issuer metadata and validates the structure is correct
     */
    createCredentialIssuerMetadata(credentialIssuerMetadata: CredentialIssuerMetadata): CredentialIssuerMetadata;
    createCredentialOffer(options: Pick<CreateCredentialOfferOptions, 'issuerMetadata' | 'additionalPayload' | 'grants' | 'credentialOfferUri' | 'credentialOfferScheme' | 'credentialConfigurationIds'>): Promise<{
        credentialOffer: string;
        credentialOfferObject: CredentialOfferObject;
    }>;
    /**
     * @throws Oauth2ServerErrorResponseError - if verification of the jwt failed. You can extract
     *  the credential error response from this.
     */
    verifyCredentialRequestJwtProof(options: Pick<VerifyCredentialRequestJwtProofOptions, 'clientId' | 'jwt' | 'now' | 'expectedNonce' | 'nonceExpiresAt'> & {
        issuerMetadata: IssuerMetadataResult;
    }): Promise<{
        header: {
            alg: string;
            typ: "openid4vci-proof+jwt";
            kid?: string | undefined;
            x5c?: string[] | undefined;
            jwk?: ({
                kty: string;
                crv?: string | undefined;
                x?: string | undefined;
                y?: string | undefined;
                e?: string | undefined;
                n?: string | undefined;
                alg?: string | undefined;
                d?: string | undefined;
                dp?: string | undefined;
                dq?: string | undefined;
                ext?: boolean | undefined;
                k?: string | undefined;
                key_ops?: string | undefined;
                kid?: string | undefined;
                oth?: ({
                    d?: string | undefined;
                    r?: string | undefined;
                    t?: string | undefined;
                } & {
                    [key: string]: unknown;
                })[] | undefined;
                p?: string | undefined;
                q?: string | undefined;
                qi?: string | undefined;
                use?: string | undefined;
                x5c?: string | undefined;
                x5t?: string | undefined;
                'x5t#S256'?: string | undefined;
                x5u?: string | undefined;
            } & {
                [key: string]: unknown;
            }) | undefined;
            trust_chain?: string[] | undefined;
            key_attestation?: string | undefined;
        } & {
            [key: string]: unknown;
        };
        payload: {
            aud: string;
            iat: number;
            iss?: string | undefined;
            exp?: number | undefined;
            nbf?: number | undefined;
            nonce?: string | undefined;
            jti?: string | undefined;
            cnf?: ({
                jwk?: ({
                    kty: string;
                    crv?: string | undefined;
                    x?: string | undefined;
                    y?: string | undefined;
                    e?: string | undefined;
                    n?: string | undefined;
                    alg?: string | undefined;
                    d?: string | undefined;
                    dp?: string | undefined;
                    dq?: string | undefined;
                    ext?: boolean | undefined;
                    k?: string | undefined;
                    key_ops?: string | undefined;
                    kid?: string | undefined;
                    oth?: ({
                        d?: string | undefined;
                        r?: string | undefined;
                        t?: string | undefined;
                    } & {
                        [key: string]: unknown;
                    })[] | undefined;
                    p?: string | undefined;
                    q?: string | undefined;
                    qi?: string | undefined;
                    use?: string | undefined;
                    x5c?: string | undefined;
                    x5t?: string | undefined;
                    'x5t#S256'?: string | undefined;
                    x5u?: string | undefined;
                } & {
                    [key: string]: unknown;
                }) | undefined;
                jkt?: string | undefined;
            } & {
                [key: string]: unknown;
            }) | undefined;
            status?: ({} & {
                [key: string]: unknown;
            }) | undefined;
        } & {
            [key: string]: unknown;
        };
        signer: _openid4vc_oauth2.JwtSignerWithJwk;
        keyAttestation: {
            header: {
                alg: string;
                typ: "keyattestation+jwt";
                kid?: string | undefined;
                x5c?: string[] | undefined;
                jwk?: ({
                    kty: string;
                    crv?: string | undefined;
                    x?: string | undefined;
                    y?: string | undefined;
                    e?: string | undefined;
                    n?: string | undefined;
                    alg?: string | undefined;
                    d?: string | undefined;
                    dp?: string | undefined;
                    dq?: string | undefined;
                    ext?: boolean | undefined;
                    k?: string | undefined;
                    key_ops?: string | undefined;
                    kid?: string | undefined;
                    oth?: ({
                        d?: string | undefined;
                        r?: string | undefined;
                        t?: string | undefined;
                    } & {
                        [key: string]: unknown;
                    })[] | undefined;
                    p?: string | undefined;
                    q?: string | undefined;
                    qi?: string | undefined;
                    use?: string | undefined;
                    x5c?: string | undefined;
                    x5t?: string | undefined;
                    'x5t#S256'?: string | undefined;
                    x5u?: string | undefined;
                } & {
                    [key: string]: unknown;
                }) | undefined;
                trust_chain?: string[] | undefined;
            } & {
                [key: string]: unknown;
            };
            payload: {
                iat: number;
                exp: number;
                nonce: string;
                attested_keys: ({
                    kty: string;
                    crv?: string | undefined;
                    x?: string | undefined;
                    y?: string | undefined;
                    e?: string | undefined;
                    n?: string | undefined;
                    alg?: string | undefined;
                    d?: string | undefined;
                    dp?: string | undefined;
                    dq?: string | undefined;
                    ext?: boolean | undefined;
                    k?: string | undefined;
                    key_ops?: string | undefined;
                    kid?: string | undefined;
                    oth?: ({
                        d?: string | undefined;
                        r?: string | undefined;
                        t?: string | undefined;
                    } & {
                        [key: string]: unknown;
                    })[] | undefined;
                    p?: string | undefined;
                    q?: string | undefined;
                    qi?: string | undefined;
                    use?: string | undefined;
                    x5c?: string | undefined;
                    x5t?: string | undefined;
                    'x5t#S256'?: string | undefined;
                    x5u?: string | undefined;
                } & {
                    [key: string]: unknown;
                })[];
                iss?: string | undefined;
                aud?: string | undefined;
                nbf?: number | undefined;
                jti?: string | undefined;
                cnf?: ({
                    jwk?: ({
                        kty: string;
                        crv?: string | undefined;
                        x?: string | undefined;
                        y?: string | undefined;
                        e?: string | undefined;
                        n?: string | undefined;
                        alg?: string | undefined;
                        d?: string | undefined;
                        dp?: string | undefined;
                        dq?: string | undefined;
                        ext?: boolean | undefined;
                        k?: string | undefined;
                        key_ops?: string | undefined;
                        kid?: string | undefined;
                        oth?: ({
                            d?: string | undefined;
                            r?: string | undefined;
                            t?: string | undefined;
                        } & {
                            [key: string]: unknown;
                        })[] | undefined;
                        p?: string | undefined;
                        q?: string | undefined;
                        qi?: string | undefined;
                        use?: string | undefined;
                        x5c?: string | undefined;
                        x5t?: string | undefined;
                        'x5t#S256'?: string | undefined;
                        x5u?: string | undefined;
                    } & {
                        [key: string]: unknown;
                    }) | undefined;
                    jkt?: string | undefined;
                } & {
                    [key: string]: unknown;
                }) | undefined;
                status?: ({} & {
                    [key: string]: unknown;
                }) | undefined;
                user_authentication?: string[] | undefined;
                key_storage?: string[] | undefined;
                certification?: string | undefined;
            } & {
                [key: string]: unknown;
            };
            signer: _openid4vc_oauth2.JwtSignerWithJwk;
        } | undefined;
    }>;
    /**
     * @throws Oauth2ServerErrorResponseError - if verification of the key attestation failed. You can extract
     *  the credential error response from this.
     */
    verifyCredentialRequestAttestationProof(options: Pick<VerifyCredentialRequestAttestationProofOptions, 'keyAttestationJwt' | 'expectedNonce' | 'nonceExpiresAt' | 'now'> & {
        issuerMetadata: IssuerMetadataResult;
    }): Promise<{
        header: {
            alg: string;
            typ: "keyattestation+jwt";
            kid?: string | undefined;
            x5c?: string[] | undefined;
            jwk?: ({
                kty: string;
                crv?: string | undefined;
                x?: string | undefined;
                y?: string | undefined;
                e?: string | undefined;
                n?: string | undefined;
                alg?: string | undefined;
                d?: string | undefined;
                dp?: string | undefined;
                dq?: string | undefined;
                ext?: boolean | undefined;
                k?: string | undefined;
                key_ops?: string | undefined;
                kid?: string | undefined;
                oth?: ({
                    d?: string | undefined;
                    r?: string | undefined;
                    t?: string | undefined;
                } & {
                    [key: string]: unknown;
                })[] | undefined;
                p?: string | undefined;
                q?: string | undefined;
                qi?: string | undefined;
                use?: string | undefined;
                x5c?: string | undefined;
                x5t?: string | undefined;
                'x5t#S256'?: string | undefined;
                x5u?: string | undefined;
            } & {
                [key: string]: unknown;
            }) | undefined;
            trust_chain?: string[] | undefined;
        } & {
            [key: string]: unknown;
        };
        payload: {
            iat: number;
            exp: number;
            nonce: string;
            attested_keys: ({
                kty: string;
                crv?: string | undefined;
                x?: string | undefined;
                y?: string | undefined;
                e?: string | undefined;
                n?: string | undefined;
                alg?: string | undefined;
                d?: string | undefined;
                dp?: string | undefined;
                dq?: string | undefined;
                ext?: boolean | undefined;
                k?: string | undefined;
                key_ops?: string | undefined;
                kid?: string | undefined;
                oth?: ({
                    d?: string | undefined;
                    r?: string | undefined;
                    t?: string | undefined;
                } & {
                    [key: string]: unknown;
                })[] | undefined;
                p?: string | undefined;
                q?: string | undefined;
                qi?: string | undefined;
                use?: string | undefined;
                x5c?: string | undefined;
                x5t?: string | undefined;
                'x5t#S256'?: string | undefined;
                x5u?: string | undefined;
            } & {
                [key: string]: unknown;
            })[];
            iss?: string | undefined;
            aud?: string | undefined;
            nbf?: number | undefined;
            jti?: string | undefined;
            cnf?: ({
                jwk?: ({
                    kty: string;
                    crv?: string | undefined;
                    x?: string | undefined;
                    y?: string | undefined;
                    e?: string | undefined;
                    n?: string | undefined;
                    alg?: string | undefined;
                    d?: string | undefined;
                    dp?: string | undefined;
                    dq?: string | undefined;
                    ext?: boolean | undefined;
                    k?: string | undefined;
                    key_ops?: string | undefined;
                    kid?: string | undefined;
                    oth?: ({
                        d?: string | undefined;
                        r?: string | undefined;
                        t?: string | undefined;
                    } & {
                        [key: string]: unknown;
                    })[] | undefined;
                    p?: string | undefined;
                    q?: string | undefined;
                    qi?: string | undefined;
                    use?: string | undefined;
                    x5c?: string | undefined;
                    x5t?: string | undefined;
                    'x5t#S256'?: string | undefined;
                    x5u?: string | undefined;
                } & {
                    [key: string]: unknown;
                }) | undefined;
                jkt?: string | undefined;
            } & {
                [key: string]: unknown;
            }) | undefined;
            status?: ({} & {
                [key: string]: unknown;
            }) | undefined;
            user_authentication?: string[] | undefined;
            key_storage?: string[] | undefined;
            certification?: string | undefined;
        } & {
            [key: string]: unknown;
        };
        signer: _openid4vc_oauth2.JwtSignerWithJwk;
    }>;
    /**
     * @throws Oauth2ServerErrorResponseError - when validation of the credential request fails
     *  You can extract the credential error response from this.
     */
    parseCredentialRequest(options: ParseCredentialRequestOptions): ParseCredentialRequestReturn;
    /**
     * @throws ValidationError - when validation of the credential response fails
     */
    createCredentialResponse(options: CreateCredentialResponseOptions): {
        c_nonce?: string | undefined;
        c_nonce_expires_in?: number | undefined;
        credentials?: (string | {
            [x: string]: any;
        })[] | undefined;
        credential?: string | {
            [x: string]: any;
        } | undefined;
        transaction_id?: string | undefined;
        notification_id?: string | undefined;
    } & {
        [key: string]: unknown;
    };
    /**
     * @throws ValidationError - when validation of the nonce response fails
     */
    createNonceResponse(options: CreateNonceResponseOptions): {
        c_nonce: string;
        c_nonce_expires_in?: number | undefined;
    } & {
        [key: string]: unknown;
    };
}

export { AuthorizationFlow, type CredenialOfferAuthorizationCodeGrant, type CredentialConfigurationSupported, type CredentialConfigurationSupportedWithFormats, type CredentialConfigurationsSupported, type CredentialConfigurationsSupportedWithFormats, type CredentialErrorResponse, type CredentialFormatIdentifier, type CredentialIssuerMetadata, type CredentialIssuerMetadataDisplayEntry, type CredentialOfferGrants, type CredentialOfferObject, type CredentialOfferPreAuthorizedCodeGrant, type CredentialOfferPreAuthorizedCodeGrantTxCode, type CredentialRequest, type CredentialRequestFormatSpecific, type CredentialRequestJwtProofTypeHeader, type CredentialRequestJwtProofTypePayload, type CredentialRequestWithFormats, type CredentialResponse, type ExtractScopesForCredentialConfigurationIdsOptions, type GetCredentialConfigurationsMatchingRequestFormatOptions, type IssuerMetadataResult, type JwtProofTypeIdentifier, type JwtVcJsonFormatIdentifier, type JwtVcJsonLdFormatIdentifier, type LdpVcFormatIdentifier, type MsoMdocFormatIdentifier, type NonceResponse, type NotificationErrorResponse, type NotificationEvent, Oid4vciClient, type Oid4vciClientOptions, Oid4vciDraftVersion, Oid4vciError, type Oid4vciErrorOptions, Oid4vciIssuer, type Oid4vciIssuerOptions, Oid4vciRetrieveCredentialsError, Oid4vciSendNotificationError, type ParseCredentialRequestReturn, type ProofTypeIdentifier, type RetrieveCredentialsResponseNotOk, type RetrieveCredentialsResponseOk, type SdJwtVcFormatIdentifier, type SendNotificationResponseNotOk, type SendNotificationResponseOk, credentialsSupportedToCredentialConfigurationsSupported, extractScopesForCredentialConfigurationIds, getCredentialConfigurationsMatchingRequestFormat };
