"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  AuthorizationFlow: () => AuthorizationFlow,
  Oid4vciClient: () => Oid4vciClient,
  Oid4vciDraftVersion: () => Oid4vciDraftVersion,
  Oid4vciError: () => Oid4vciError,
  Oid4vciIssuer: () => Oid4vciIssuer,
  Oid4vciRetrieveCredentialsError: () => Oid4vciRetrieveCredentialsError,
  Oid4vciSendNotificationError: () => Oid4vciSendNotificationError,
  credentialsSupportedToCredentialConfigurationsSupported: () => credentialsSupportedToCredentialConfigurationsSupported,
  extractScopesForCredentialConfigurationIds: () => extractScopesForCredentialConfigurationIds,
  getCredentialConfigurationsMatchingRequestFormat: () => getCredentialConfigurationsMatchingRequestFormat,
  getGlobalConfig: () => import_utils19.getGlobalConfig,
  setGlobalConfig: () => import_utils19.setGlobalConfig
});
module.exports = __toCommonJS(src_exports);
var import_utils19 = require("@openid4vc/utils");

// src/credential-request/credential-request-configurations.ts
var import_utils4 = require("@openid4vc/utils");

// src/metadata/credential-issuer/credential-issuer-metadata.ts
var import_oauth23 = require("@openid4vc/oauth2");
var import_utils3 = require("@openid4vc/utils");

// src/metadata/credential-issuer/v-credential-issuer-metadata.ts
var import_oauth22 = require("@openid4vc/oauth2");
var import_utils2 = require("@openid4vc/utils");
var v9 = __toESM(require("valibot"));

// src/formats/credential/mso-mdoc/v-mso-mdoc.ts
var v3 = __toESM(require("valibot"));

// src/metadata/credential-issuer/v-credential-configuration-supported-common.ts
var v2 = __toESM(require("valibot"));

// src/key-attestation/v-key-attestation.ts
var v = __toESM(require("valibot"));
var import_oauth2 = require("@openid4vc/oauth2");
var import_utils = require("@openid4vc/utils");
var vKeyAttestationJwtHeader = v.pipe(
  v.looseObject({
    ...import_oauth2.vJwtHeader.entries,
    typ: v.literal("keyattestation+jwt")
  }),
  v.check(
    ({ kid, jwk }) => jwk === void 0 || kid === void 0,
    `Both 'jwk' and 'kid' are defined. Only one is allowed`
  ),
  v.check(({ trust_chain, kid }) => !trust_chain || !kid, `When 'trust_chain' is provided, 'kid' is required`)
);
var vIso18045 = v.picklist([
  "iso_18045_high",
  "iso_18045_moderate",
  "iso_18045_enhanced-basic",
  "iso_18045_basic"
]);
var vIso18045OrStringArray = v.array(v.union([vIso18045, v.string()]));
var vKeyAttestationJwtPayload = v.looseObject({
  ...import_oauth2.vJwtPayload.entries,
  iat: import_utils.vInteger,
  attested_keys: v.array(import_oauth2.vJwk),
  key_storage: v.optional(vIso18045OrStringArray),
  user_authentication: v.optional(vIso18045OrStringArray),
  certification: v.optional(v.string())
});
var vKeyAttestationJwtPayloadForUse = (use) => v.looseObject({
  ...vKeyAttestationJwtPayload.entries,
  // REQUIRED when used as proof_type.attesation directly
  nonce: use === "proof_type.attestation" ? v.string(`Nonce must be defined when key attestation is used as 'proof_type.attestation' directly`) : v.optional(v.string()),
  // REQUIRED when used within header of proof_type.jwt
  exp: use === "proof_type.jwt" ? import_utils.vInteger : v.optional(import_utils.vInteger)
});

// src/metadata/credential-issuer/v-credential-configuration-supported-common.ts
var vCredentialConfigurationSupportedClaims = v2.looseObject({
  mandatory: v2.optional(v2.boolean()),
  value_type: v2.optional(v2.string()),
  display: v2.optional(
    v2.looseObject({
      name: v2.optional(v2.string()),
      locale: v2.optional(v2.string())
    })
  )
});
var vCredentialConfigurationSupportedCommon = v2.looseObject({
  format: v2.string(),
  scope: v2.optional(v2.string()),
  cryptographic_binding_methods_supported: v2.optional(v2.array(v2.string())),
  credential_signing_alg_values_supported: v2.optional(v2.array(v2.string())),
  proof_types_supported: v2.optional(
    v2.record(
      v2.union([v2.literal("jwt"), v2.literal("attestation"), v2.string()]),
      v2.object({
        proof_signing_alg_values_supported: v2.array(v2.string()),
        key_attestations_required: v2.optional(
          v2.looseObject({
            key_storage: v2.optional(vIso18045OrStringArray),
            user_authentication: v2.optional(vIso18045OrStringArray)
          })
        )
      })
    )
  ),
  display: v2.optional(
    v2.array(
      v2.looseObject({
        name: v2.string(),
        locale: v2.optional(v2.string()),
        logo: v2.optional(
          v2.looseObject({
            // FIXME: make required again, but need to support draft 11 first
            uri: v2.optional(v2.string()),
            alt_text: v2.optional(v2.string())
          })
        ),
        description: v2.optional(v2.string()),
        background_color: v2.optional(v2.string()),
        background_image: v2.optional(
          v2.looseObject({
            // TODO: should be required, but paradym's metadata is wrong here.
            uri: v2.optional(v2.string())
          })
        ),
        text_color: v2.optional(v2.string())
      })
    )
  )
});

// src/formats/credential/mso-mdoc/v-mso-mdoc.ts
var vMsoMdocFormatIdentifier = v3.literal("mso_mdoc");
var vMsoMdocCredentialIssuerMetadata = v3.object({
  format: vMsoMdocFormatIdentifier,
  doctype: v3.string(),
  claims: v3.optional(vCredentialConfigurationSupportedClaims),
  order: v3.optional(v3.array(v3.pipe(v3.string(), v3.includes("~"))))
});
var vMsoMdocCredentialRequestFormat = v3.object({
  format: vMsoMdocFormatIdentifier,
  doctype: v3.string(),
  claims: v3.optional(vCredentialConfigurationSupportedClaims)
});

// src/formats/credential/sd-jwt-vc/v-sd-jwt-vc.ts
var v4 = __toESM(require("valibot"));
var vSdJwtVcFormatIdentifier = v4.literal("vc+sd-jwt");
var vSdJwtVcCredentialIssuerMetadata = v4.object({
  vct: v4.string(),
  format: vSdJwtVcFormatIdentifier,
  claims: v4.optional(vCredentialConfigurationSupportedClaims),
  order: v4.optional(v4.array(v4.string()))
});
var vSdJwtVcCredentialRequestFormat = v4.object({
  format: vSdJwtVcFormatIdentifier,
  vct: v4.string(),
  claims: v4.optional(vCredentialConfigurationSupportedClaims)
});

// src/formats/credential/w3c-vc/v-w3c-ldp-vc.ts
var v6 = __toESM(require("valibot"));

// src/formats/credential/w3c-vc/v-w3c-vc-common.ts
var v5 = __toESM(require("valibot"));
var vCredentialSubjectLeafType = v5.looseObject({
  mandatory: v5.optional(v5.boolean(), false),
  value_type: v5.optional(v5.string()),
  display: v5.optional(
    v5.array(
      v5.looseObject({
        name: v5.optional(v5.string()),
        locale: v5.optional(v5.string())
      })
    )
  )
});
var vClaimValueSchema = v5.union([v5.array(v5.any()), v5.record(v5.string(), v5.any()), vCredentialSubjectLeafType]);
var vW3cVcCredentialSubject = v5.record(v5.string(), vClaimValueSchema);
var vW3cVcJsonLdCredentialDefinition = v5.looseObject({
  "@context": v5.array(v5.string()),
  type: v5.array(v5.string()),
  credentialSubject: v5.optional(vW3cVcCredentialSubject)
});

// src/formats/credential/w3c-vc/v-w3c-ldp-vc.ts
var vLdpVcFormatIdentifier = v6.literal("ldp_vc");
var vLdpVcCredentialIssuerMetadata = v6.object({
  format: vLdpVcFormatIdentifier,
  credential_definition: vW3cVcJsonLdCredentialDefinition,
  order: v6.optional(v6.array(v6.string()))
});
var vLdpVcCredentialIssuerMetadataDraft11 = v6.looseObject({
  order: v6.optional(v6.array(v6.string())),
  format: vLdpVcFormatIdentifier,
  // Credential definition was spread on top level instead of a separatey property in v11
  // As well as using types instead of type
  "@context": v6.array(v6.string()),
  types: v6.array(v6.string()),
  credentialSubject: v6.optional(vW3cVcCredentialSubject)
});
var vLdpVcCredentialIssuerMetadataDraft11To14 = v6.pipe(
  vLdpVcCredentialIssuerMetadataDraft11,
  v6.transform(({ "@context": context, types, credentialSubject, ...rest }) => ({
    ...rest,
    credential_definition: {
      "@context": context,
      type: types,
      // Prevent weird typing issue with optional vs undefined
      ...credentialSubject ? { credentialSubject } : {}
    }
  }))
);
var vLdpVcCredentialIssuerMetadataDraft14To11 = v6.pipe(
  v6.looseObject({ ...vLdpVcCredentialIssuerMetadata.entries }),
  v6.transform(({ credential_definition: { type, ...credentialDefinition }, ...rest }) => ({
    ...rest,
    ...credentialDefinition,
    types: type
  })),
  vLdpVcCredentialIssuerMetadataDraft11
);
var vLdpVcCredentialRequestFormat = v6.object({
  format: vLdpVcFormatIdentifier,
  credential_definition: vW3cVcJsonLdCredentialDefinition
});
var vLdpVcCredentialRequestDraft11 = v6.looseObject({
  format: vLdpVcFormatIdentifier,
  credential_definition: v6.object({
    "@context": v6.array(v6.string()),
    // credential_definition was using types instead of type in v11
    types: v6.array(v6.string()),
    credentialSubject: v6.optional(vW3cVcCredentialSubject)
  })
});
var vLdpVcCredentialRequestDraft11To14 = v6.pipe(
  vLdpVcCredentialRequestDraft11,
  v6.transform(({ credential_definition: { types, ...restCredentialDefinition }, ...rest }) => ({
    ...rest,
    credential_definition: {
      ...restCredentialDefinition,
      type: types
    }
  }))
);
var vLdpVcCredentialRequestDraft14To11 = v6.pipe(
  v6.looseObject({ ...vLdpVcCredentialRequestFormat.entries }),
  v6.transform(({ credential_definition: { type, ...credentialDefinition }, ...rest }) => ({
    ...rest,
    credential_definition: {
      ...credentialDefinition,
      types: type
    }
  })),
  vLdpVcCredentialRequestDraft11
);

// src/formats/credential/w3c-vc/v-w3c-jwt-vc-json-ld.ts
var v7 = __toESM(require("valibot"));
var vJwtVcJsonLdFormatIdentifier = v7.literal("jwt_vc_json-ld");
var vJwtVcJsonLdCredentialIssuerMetadata = v7.object({
  format: vJwtVcJsonLdFormatIdentifier,
  credential_definition: vW3cVcJsonLdCredentialDefinition,
  order: v7.optional(v7.array(v7.string()))
});
var vJwtVcJsonLdCredentialIssuerMetadataDraft11 = v7.looseObject({
  order: v7.optional(v7.array(v7.string())),
  format: vJwtVcJsonLdFormatIdentifier,
  // Credential definition was spread on top level instead of a separatey property in v11
  // As well as using types instead of type
  "@context": v7.array(v7.string()),
  types: v7.array(v7.string()),
  credentialSubject: v7.optional(vW3cVcCredentialSubject)
});
var vJwtVcJsonLdCredentialIssuerMetadataDraft11To14 = v7.pipe(
  vJwtVcJsonLdCredentialIssuerMetadataDraft11,
  v7.transform(({ "@context": context, types, credentialSubject, ...rest }) => ({
    ...rest,
    credential_definition: {
      "@context": context,
      type: types,
      // Prevent weird typing issue with optional vs undefined
      ...credentialSubject ? { credentialSubject } : {}
    }
  }))
);
var vJwtVcJsonLdCredentialIssuerMetadataDraft14To11 = v7.pipe(
  v7.looseObject({ ...vJwtVcJsonLdCredentialIssuerMetadata.entries }),
  v7.transform(({ credential_definition: { type, ...credentialDefinition }, ...rest }) => ({
    ...rest,
    ...credentialDefinition,
    types: type
  })),
  vJwtVcJsonLdCredentialIssuerMetadataDraft11
);
var vJwtVcJsonLdCredentialRequestFormat = v7.object({
  format: vJwtVcJsonLdFormatIdentifier,
  credential_definition: vW3cVcJsonLdCredentialDefinition
});
var vJwtVcJsonLdCredentialRequestDraft11 = v7.looseObject({
  format: vJwtVcJsonLdFormatIdentifier,
  credential_definition: v7.looseObject({
    "@context": v7.array(v7.string()),
    // credential_definition was using types instead of type in v11
    types: v7.array(v7.string()),
    credentialSubject: v7.optional(vW3cVcCredentialSubject)
  })
});
var vJwtVcJsonLdCredentialRequestDraft11To14 = v7.pipe(
  vJwtVcJsonLdCredentialRequestDraft11,
  v7.transform(({ credential_definition: { types, ...restCredentialDefinition }, ...rest }) => ({
    ...rest,
    credential_definition: {
      ...restCredentialDefinition,
      type: types
    }
  }))
);
var vJwtVcJsonLdCredentialRequestDraft14To11 = v7.pipe(
  v7.looseObject({ ...vJwtVcJsonLdCredentialRequestFormat.entries }),
  v7.transform(({ credential_definition: { type, ...restCredentialDefinition }, ...rest }) => ({
    ...rest,
    credential_definition: {
      ...restCredentialDefinition,
      types: type
    }
  })),
  vJwtVcJsonLdCredentialRequestDraft11
);

// src/formats/credential/w3c-vc/v-w3c-jwt-vc-json.ts
var v8 = __toESM(require("valibot"));
var vJwtVcJsonFormatIdentifier = v8.literal("jwt_vc_json");
var vJwtVcJsonCredentialDefinition = v8.looseObject({
  type: v8.array(v8.string()),
  credentialSubject: v8.optional(vW3cVcCredentialSubject)
});
var vJwtVcJsonCredentialIssuerMetadata = v8.object({
  format: vJwtVcJsonFormatIdentifier,
  credential_definition: vJwtVcJsonCredentialDefinition,
  order: v8.optional(v8.array(v8.string()))
});
var vJwtVcJsonCredentialIssuerMetadataDraft11 = v8.looseObject({
  format: vJwtVcJsonFormatIdentifier,
  order: v8.optional(v8.array(v8.string())),
  // Credential definition was spread on top level instead of a separatey property in v11
  // As well as using types instead of type
  types: v8.array(v8.string()),
  credentialSubject: v8.optional(vW3cVcCredentialSubject)
});
var vJwtVcJsonCredentialIssuerMetadataDraft11To14 = v8.pipe(
  vJwtVcJsonCredentialIssuerMetadataDraft11,
  v8.transform(({ types, credentialSubject, ...rest }) => ({
    ...rest,
    credential_definition: {
      type: types,
      // Prevent weird typing issue with optional vs undefined
      ...credentialSubject ? { credentialSubject } : {}
    }
  }))
);
var vJwtVcJsonCredentialIssuerMetadataDraft14To11 = v8.pipe(
  v8.looseObject({ ...vJwtVcJsonCredentialIssuerMetadata.entries }),
  v8.transform(({ credential_definition: { type, ...credentialDefinition }, ...rest }) => ({
    ...rest,
    types: type,
    ...credentialDefinition
  })),
  vJwtVcJsonCredentialIssuerMetadataDraft11
);
var vJwtVcJsonCredentialRequestFormat = v8.object({
  format: vJwtVcJsonFormatIdentifier,
  credential_definition: vJwtVcJsonCredentialDefinition
});
var vJwtVcJsonCredentialRequestDraft11 = v8.looseObject({
  format: vJwtVcJsonFormatIdentifier,
  // Credential definition was spread on top level instead of a separatey property in v11
  // As well as using types instead of type
  types: v8.array(v8.string()),
  credentialSubject: v8.optional(vW3cVcCredentialSubject)
});
var vJwtVcJsonCredentialRequestDraft11To14 = v8.pipe(
  vJwtVcJsonCredentialRequestDraft11,
  v8.transform(({ types, credentialSubject, ...rest }) => ({
    ...rest,
    credential_definition: {
      type: types,
      // Prevent weird typing issue with optional vs undefined
      ...credentialSubject ? { credentialSubject } : {}
    }
  }))
);
var vJwtVcJsonCredentialRequestDraft14To11 = v8.pipe(
  v8.looseObject({ ...vJwtVcJsonCredentialRequestFormat.entries }),
  v8.transform(({ credential_definition: { type, ...credentialDefinition }, ...rest }) => ({
    ...rest,
    types: type,
    ...credentialDefinition
  })),
  vJwtVcJsonCredentialRequestDraft11
);

// src/version.ts
var Oid4vciDraftVersion = /* @__PURE__ */ ((Oid4vciDraftVersion2) => {
  Oid4vciDraftVersion2["Draft14"] = "Draft14";
  Oid4vciDraftVersion2["Draft11"] = "Draft11";
  return Oid4vciDraftVersion2;
})(Oid4vciDraftVersion || {});

// src/metadata/credential-issuer/v-credential-issuer-metadata.ts
var allCredentialIssuerMetadataFormats = [
  vSdJwtVcCredentialIssuerMetadata,
  vMsoMdocCredentialIssuerMetadata,
  vJwtVcJsonLdCredentialIssuerMetadata,
  vLdpVcCredentialIssuerMetadata,
  vJwtVcJsonCredentialIssuerMetadata
];
var allCredentialIssuerMetadataFormatIdentifiers = allCredentialIssuerMetadataFormats.map(
  (format) => format.entries.format.literal
);
var vCredentialConfigurationSupportedWithFormats = v9.intersect([
  v9.variant("format", [
    ...allCredentialIssuerMetadataFormats,
    // To handle unrecognized formats and not error immediately we allow the common format as well
    // but they can't use any of the foramt identifiers already regsitered. This way if a format is
    // recognized it NEEDS to use the format specific validation, and otherwise we fall back to the common validation
    v9.looseObject({
      format: v9.pipe(
        v9.string(),
        v9.check((input) => !allCredentialIssuerMetadataFormatIdentifiers.includes(input))
      )
    })
  ]),
  vCredentialConfigurationSupportedCommon
]);
var vCredentialIssuerMetadataDisplayEntry = v9.looseObject({
  name: v9.optional(v9.string()),
  locale: v9.optional(v9.string()),
  logo: v9.optional(
    v9.looseObject({
      // FIXME: make required again, but need to support draft 11 first
      uri: v9.optional(v9.string()),
      alt_text: v9.optional(v9.string())
    })
  )
});
var vCredentialIssuerMetadataDraft14 = v9.looseObject({
  credential_issuer: import_utils2.vHttpsUrl,
  authorization_servers: v9.optional(v9.array(import_utils2.vHttpsUrl)),
  credential_endpoint: import_utils2.vHttpsUrl,
  deferred_credential_endpoint: v9.optional(import_utils2.vHttpsUrl),
  notification_endpoint: v9.optional(import_utils2.vHttpsUrl),
  // Added after draft 14, but needed for proper
  nonce_endpoint: v9.optional(import_utils2.vHttpsUrl),
  credential_response_encryption: v9.optional(
    v9.looseObject({
      alg_values_supported: v9.array(v9.string()),
      enc_values_supported: v9.array(v9.string()),
      encryption_required: v9.boolean()
    })
  ),
  batch_credential_issuance: v9.optional(
    v9.looseObject({
      batch_size: v9.pipe(v9.number(), v9.integer())
    })
  ),
  signed_metadata: v9.optional(import_oauth22.vCompactJwt),
  display: v9.optional(v9.array(vCredentialIssuerMetadataDisplayEntry)),
  credential_configurations_supported: v9.record(v9.string(), vCredentialConfigurationSupportedWithFormats)
});
var vCredentialConfigurationSupportedDraft11To14 = v9.pipe(
  v9.looseObject({
    id: v9.optional(v9.string()),
    format: v9.string(),
    cryptographic_suites_supported: v9.optional(v9.array(v9.string())),
    display: v9.optional(
      v9.array(
        v9.looseObject({
          logo: v9.optional(
            v9.looseObject({
              url: v9.optional(v9.pipe(v9.string(), v9.url()))
            })
          ),
          background_image: v9.optional(
            v9.looseObject({
              url: v9.optional(v9.pipe(v9.string(), v9.url()))
            })
          )
        })
      )
    )
  }),
  v9.transform(({ cryptographic_suites_supported, display, id, ...rest }) => ({
    ...rest,
    ...cryptographic_suites_supported ? { credential_signing_alg_values_supported: cryptographic_suites_supported } : {},
    ...display ? {
      display: display.map(({ logo, background_image, ...displayRest }) => ({
        ...displayRest,
        // url became uri and also required
        // so if there's no url in the logo, we remove the whole logo object
        ...logo?.url ? {
          logo: {
            uri: logo.url
          }
        } : {},
        // url became uri and also required
        // so if there's no url in the background_image, we remove the whole logo object
        ...background_image?.url ? {
          background_image: {
            uri: background_image.url
          }
        } : {}
      }))
    } : {}
  })),
  v9.variant("format", [
    vLdpVcCredentialIssuerMetadataDraft11To14,
    vJwtVcJsonCredentialIssuerMetadataDraft11To14,
    vJwtVcJsonLdCredentialIssuerMetadataDraft11To14,
    // To handle unrecognized formats and not error immediately we allow the common format as well
    // but they can't use any of the foramt identifiers that have a specific transformation. This way if a format is
    // has a transformation it NEEDS to use the format specific transformation, and otherwise we fall back to the common validation
    v9.looseObject({
      format: v9.pipe(
        v9.string(),
        v9.check(
          (input) => ![
            vLdpVcFormatIdentifier.literal,
            vJwtVcJsonFormatIdentifier.literal,
            vJwtVcJsonLdFormatIdentifier.literal
          ].includes(input)
        )
      )
    })
  ]),
  vCredentialConfigurationSupportedWithFormats
);
var vCredentialConfigurationSupportedDraft14To11 = v9.pipe(
  v9.intersect([v9.looseObject({ id: v9.string() }), vCredentialConfigurationSupportedWithFormats]),
  v9.transform(({ id, credential_signing_alg_values_supported, display, proof_types_supported, scope, ...rest }) => ({
    ...rest,
    ...credential_signing_alg_values_supported ? { cryptographic_suites_supported: credential_signing_alg_values_supported } : {},
    ...display ? {
      display: display.map(({ logo, background_image, ...displayRest }) => {
        const { uri: logoUri, ...logoRest } = logo ?? {};
        const { uri: backgroundImageUri, ...backgroundImageRest } = background_image ?? {};
        return {
          ...displayRest,
          // draft 11 uses url, draft 13/14 uses uri
          ...logoUri ? { logo: { url: logoUri, ...logoRest } } : {},
          // draft 11 uses url, draft 13/14 uses uri
          ...backgroundImageUri ? { logo: { url: backgroundImageUri, ...backgroundImageRest } } : {}
        };
      })
    } : {},
    id
  })),
  v9.intersect([
    v9.looseObject({ id: v9.string() }),
    v9.variant("format", [
      vLdpVcCredentialIssuerMetadataDraft14To11,
      vJwtVcJsonCredentialIssuerMetadataDraft14To11,
      vJwtVcJsonLdCredentialIssuerMetadataDraft14To11,
      // To handle unrecognized formats and not error immediately we allow the common format as well
      // but they can't use any of the foramt identifiers that have a specific transformation. This way if a format is
      // has a transformation it NEEDS to use the format specific transformation, and otherwise we fall back to the common validation
      v9.looseObject({
        format: v9.pipe(
          v9.string(),
          v9.check(
            (input) => ![
              vLdpVcFormatIdentifier.literal,
              vJwtVcJsonFormatIdentifier.literal,
              vJwtVcJsonLdFormatIdentifier.literal
            ].includes(input)
          )
        )
      })
    ])
  ])
);
var vCredentialIssuerMetadataDraft11To14 = v9.pipe(
  v9.looseObject({
    authorization_server: v9.optional(v9.string()),
    credentials_supported: v9.array(
      v9.looseObject({
        id: v9.optional(v9.string())
      })
    )
  }),
  v9.transform(({ authorization_server, credentials_supported, ...rest }) => {
    return {
      ...rest,
      ...authorization_server ? { authorization_servers: [authorization_server] } : {},
      // Go from array to map but keep v11 structure
      credential_configurations_supported: Object.fromEntries(
        credentials_supported.map((supported) => supported.id ? [supported.id, supported] : void 0).filter((i) => i !== void 0)
      )
    };
  }),
  v9.looseObject({
    // Update from v11 structrue to v14 structure
    credential_configurations_supported: v9.record(v9.string(), vCredentialConfigurationSupportedDraft11To14)
  }),
  vCredentialIssuerMetadataDraft14
);
var vCredentialIssuerMetadataWithDraft11 = v9.pipe(
  vCredentialIssuerMetadataDraft14,
  v9.transform((issuerMetadata) => ({
    ...issuerMetadata,
    ...issuerMetadata.authorization_servers ? { authorization_server: issuerMetadata.authorization_servers[0] } : {},
    credentials_supported: Object.entries(issuerMetadata.credential_configurations_supported).map(([id, value]) => ({
      ...value,
      id
    }))
  })),
  v9.intersect([
    vCredentialIssuerMetadataDraft14,
    v9.looseObject({
      credentials_supported: v9.array(vCredentialConfigurationSupportedDraft14To11)
    })
  ])
);
var vCredentialIssuerMetadata = v9.union([
  // First prioritize draft 14 (and 13)
  vCredentialIssuerMetadataDraft14,
  // Then try parsing draft 11 and transform into draft 14
  vCredentialIssuerMetadataDraft11To14
]);
var vCredentialIssuerMetadataWithDraftVersion = v9.union([
  // First prioritize draft 14 (and 13)
  v9.pipe(
    vCredentialIssuerMetadataDraft14,
    v9.transform((credentialIssuerMetadata) => ({
      credentialIssuerMetadata,
      originalDraftVersion: "Draft14" /* Draft14 */
    }))
  ),
  // Then try parsing draft 11 and transform into draft 14
  v9.pipe(
    vCredentialIssuerMetadataDraft11To14,
    v9.transform((credentialIssuerMetadata) => ({
      credentialIssuerMetadata,
      originalDraftVersion: "Draft11" /* Draft11 */
    }))
  )
]);

// src/metadata/credential-issuer/credential-issuer-metadata.ts
var wellKnownCredentialIssuerSuffix = ".well-known/openid-credential-issuer";
async function fetchCredentialIssuerMetadata(credentialIssuer, fetch) {
  const wellKnownMetadataUrl = (0, import_utils3.joinUriParts)(credentialIssuer, [wellKnownCredentialIssuerSuffix]);
  const result = await (0, import_oauth23.fetchWellKnownMetadata)(wellKnownMetadataUrl, vCredentialIssuerMetadataWithDraftVersion, fetch);
  if (result && result.credentialIssuerMetadata.credential_issuer !== credentialIssuer) {
    throw new import_oauth23.Oauth2Error(
      `The 'credential_issuer' parameter '${result.credentialIssuerMetadata.credential_issuer}' in the well known credential issuer metadata at '${wellKnownMetadataUrl}' does not match the provided credential issuer '${credentialIssuer}'.`
    );
  }
  return result;
}
function extractKnownCredentialConfigurationSupportedFormats(credentialConfigurationsSupported) {
  return Object.fromEntries(
    Object.entries(credentialConfigurationsSupported).filter(
      (entry) => allCredentialIssuerMetadataFormatIdentifiers.includes(entry[1].format)
    )
  );
}

// src/credential-request/credential-request-configurations.ts
function getCredentialConfigurationsMatchingRequestFormat({
  requestFormat,
  credentialConfigurations
}) {
  const knownCredentialConfigurations = extractKnownCredentialConfigurationSupportedFormats(credentialConfigurations);
  return Object.fromEntries(
    Object.entries(knownCredentialConfigurations).filter(([, credentialConfiguration]) => {
      if (credentialConfiguration.format !== requestFormat.format) return false;
      const r = requestFormat;
      const c = credentialConfiguration;
      if ((c.format === "ldp_vc" || c.format === "jwt_vc_json-ld") && r.format === c.format) {
        return (0, import_utils4.arrayEqualsIgnoreOrder)(r.credential_definition.type, c.credential_definition.type) && (0, import_utils4.arrayEqualsIgnoreOrder)(r.credential_definition["@context"], c.credential_definition["@context"]);
      }
      if (c.format === "jwt_vc_json" && r.format === c.format) {
        return (0, import_utils4.arrayEqualsIgnoreOrder)(r.credential_definition.type, c.credential_definition.type);
      }
      if (c.format === "vc+sd-jwt" && r.format === c.format) {
        return r.vct === c.vct;
      }
      if (c.format === "mso_mdoc" && r.format === c.format) {
        return r.doctype === c.doctype;
      }
      return false;
    })
  );
}

// src/error/Oid4vciError.ts
var Oid4vciError = class extends Error {
  constructor(message, options) {
    const errorMessage = message ?? "Unknown error occured.";
    const causeMessage = options?.cause instanceof Error ? ` ${options.cause.message}` : options?.cause ? ` ${options?.cause}` : "";
    super(`${errorMessage}${causeMessage}`);
    this.cause = options?.cause;
  }
};

// src/error/Oid4vciRetrieveCredentialsError.ts
var Oid4vciRetrieveCredentialsError = class extends Oid4vciError {
  constructor(message, response, responseText) {
    super(
      `${message}
${JSON.stringify(response.credentialResponseResult?.output ?? response.credentialErrorResponseResult?.output ?? responseText, null, 2)}`
    );
    this.response = response;
  }
};

// src/error/Oid4vciSendNotificationError.ts
var Oid4vciSendNotificationError = class extends Oid4vciError {
  constructor(message, response) {
    super(message);
    this.response = response;
  }
};

// src/metadata/credential-issuer/credential-configurations.ts
var import_oauth24 = require("@openid4vc/oauth2");
var import_utils5 = require("@openid4vc/utils");
var v10 = __toESM(require("valibot"));
function extractScopesForCredentialConfigurationIds(options) {
  const scopes = /* @__PURE__ */ new Set();
  for (const credentialConfigurationId of options.credentialConfigurationIds) {
    const credentialConfiguration = options.issuerMetadata.credentialIssuer.credential_configurations_supported[credentialConfigurationId];
    if (!credentialConfiguration) {
      throw new import_oauth24.Oauth2Error(
        `Credential configuration with id '${credentialConfigurationId}' not found in metadata from credential issuer '${options.issuerMetadata.credentialIssuer.credential_issuer}'`
      );
    }
    const scope = credentialConfiguration.scope;
    if (scope) scopes.add(scope);
    else if (!scope && options.throwOnConfigurationWithoutScope) {
      throw new import_oauth24.Oauth2Error(
        `Credential configuration with id '${credentialConfigurationId}' does not have a 'scope' configured, and 'throwOnConfigurationWithoutScope' was enabled.`
      );
    }
  }
  return scopes.size > 0 ? Array.from(scopes) : void 0;
}
function credentialsSupportedToCredentialConfigurationsSupported(credentialsSupported) {
  const credentialConfigurationsSupported = {};
  for (let index = 0; index < credentialsSupported.length; index++) {
    const credentialSupported = credentialsSupported[index];
    if (!credentialSupported.id) {
      throw new Oid4vciError(
        `Credential supported at index '${index}' does not have an 'id' property. Credential configuration requires the 'id' property as key`
      );
    }
    const parseResult = v10.safeParse(vCredentialConfigurationSupportedDraft11To14, credentialSupported);
    if (!parseResult.success) {
      throw new import_utils5.ValidationError(
        `Error transforming credential supported with id '${credentialSupported.id}' to credential configuration supported format`,
        parseResult.issues
      );
    }
    credentialConfigurationsSupported[credentialSupported.id] = parseResult.output;
  }
  return credentialConfigurationsSupported;
}

// src/Oid4vciClient.ts
var import_oauth218 = require("@openid4vc/oauth2");

// src/credential-offer/credential-offer.ts
var v12 = __toESM(require("valibot"));
var import_oauth26 = require("@openid4vc/oauth2");
var import_utils7 = require("@openid4vc/utils");

// src/credential-offer/v-credential-offer.ts
var import_oauth25 = require("@openid4vc/oauth2");
var import_utils6 = require("@openid4vc/utils");
var v11 = __toESM(require("valibot"));
var vTxCode = v11.looseObject({
  input_mode: v11.optional(v11.union([v11.literal("numeric"), v11.literal("text")])),
  length: v11.optional(v11.pipe(v11.number(), v11.integer())),
  description: v11.optional(v11.pipe(v11.string(), v11.maxLength(300)))
});
var vCredentialOfferGrants = v11.looseObject({
  authorization_code: v11.optional(
    v11.looseObject({
      issuer_state: v11.optional(v11.string()),
      authorization_server: v11.optional(import_utils6.vHttpsUrl)
    })
  ),
  [import_oauth25.preAuthorizedCodeGrantIdentifier]: v11.optional(
    v11.looseObject({
      "pre-authorized_code": v11.string(),
      tx_code: v11.optional(vTxCode),
      authorization_server: v11.optional(import_utils6.vHttpsUrl)
    })
  )
});
var vCredentialOfferObjectDraft14 = v11.looseObject({
  credential_issuer: import_utils6.vHttpsUrl,
  credential_configuration_ids: v11.array(v11.string()),
  grants: v11.optional(vCredentialOfferGrants)
});
var vCredentialOfferObjectDraft11To14 = v11.pipe(
  v11.looseObject({
    credential_issuer: import_utils6.vHttpsUrl,
    // We don't support the inline offer objects from draft 11
    credentials: v11.array(v11.string(), "Only string credential identifiers are supported for draft 11 credential offers"),
    grants: v11.optional(
      v11.looseObject({
        // Has extra param in draft 14, but doesn't matter for transform purposes
        authorization_code: vCredentialOfferGrants.entries.authorization_code,
        [import_oauth25.preAuthorizedCodeGrantIdentifier]: v11.optional(
          v11.looseObject({
            "pre-authorized_code": v11.string(),
            user_pin_required: v11.optional(v11.boolean())
          })
        )
      })
    )
  }),
  v11.transform(({ credentials, grants, ...rest }) => {
    const v142 = {
      ...rest,
      credential_configuration_ids: credentials
    };
    if (grants) {
      v142.grants = { ...grants };
      if (grants[import_oauth25.preAuthorizedCodeGrantIdentifier]) {
        const { user_pin_required, ...restGrants } = grants[import_oauth25.preAuthorizedCodeGrantIdentifier];
        v142.grants[import_oauth25.preAuthorizedCodeGrantIdentifier] = {
          ...restGrants
        };
        if (user_pin_required) {
          v142.grants[import_oauth25.preAuthorizedCodeGrantIdentifier].tx_code = {
            input_mode: "text"
          };
        }
      }
    }
    return v142;
  }),
  vCredentialOfferObjectDraft14
);
var vCredentialOfferObject = v11.union([
  // First prioritize draft 14 (and 13)
  vCredentialOfferObjectDraft14,
  // Then try parsing draft 11 and transform into draft 14
  vCredentialOfferObjectDraft11To14
]);

// src/credential-offer/credential-offer.ts
async function resolveCredentialOffer(credentialOffer, options) {
  const parsedQueryParams = (0, import_utils7.getQueryParams)(credentialOffer);
  let credentialOfferParseResult;
  if (parsedQueryParams.credential_offer_uri) {
    const fetchWithValibot = (0, import_utils7.createValibotFetcher)(options?.fetch);
    const { response, result } = await fetchWithValibot(
      vCredentialOfferObject,
      import_utils7.ContentType.Json,
      parsedQueryParams.credential_offer_uri
    );
    if (!response.ok || !result) {
      throw new import_oauth26.InvalidFetchResponseError(
        `Fetching credential offer from '${parsedQueryParams.credential_offer_uri}' resulted in an unsuccesfull response with status '${response.status}'`,
        await response.clone().text(),
        response
      );
    }
    credentialOfferParseResult = result;
  } else if (parsedQueryParams.credential_offer) {
    let credentialOfferJson;
    try {
      credentialOfferJson = JSON.parse(decodeURIComponent(parsedQueryParams.credential_offer));
    } catch (error) {
      throw new import_oauth26.Oauth2Error(`Error parsing JSON from 'credential_offer' param in credential offer '${credentialOffer}'`);
    }
    credentialOfferParseResult = v12.safeParse(vCredentialOfferObject, credentialOfferJson);
  } else {
    throw new import_oauth26.Oauth2Error(`Credential offer did not contain either 'credential_offer' or 'credential_offer_uri' param.`);
  }
  if (credentialOfferParseResult.issues) {
    throw new import_utils7.ValidationError(
      `Error parsing credential offer in draft 11, 13 or 14 format extracted from credential offer '${credentialOffer}'`,
      credentialOfferParseResult.issues
    );
  }
  return credentialOfferParseResult.output;
}
function determineAuthorizationServerForCredentialOffer(options) {
  const authorizationServers = options.issuerMetadata.credentialIssuer.authorization_servers;
  let authorizationServer;
  if (options.grantAuthorizationServer) {
    authorizationServer = options.grantAuthorizationServer;
    if (!authorizationServers) {
      throw new import_oauth26.Oauth2Error(
        `Credential offer grant contains 'authorization_server' with value '${options.grantAuthorizationServer}' but credential issuer metadata does not have an 'authorization_servers' property to match the value against.`
      );
    }
    if (!authorizationServers.includes(authorizationServer)) {
      throw new import_oauth26.Oauth2Error(
        `Credential offer grant contains 'authorization_server' with value '${options.grantAuthorizationServer}' but credential issuer metadata does not include this authorization server. Available 'authorization_server' values are ${authorizationServers.join(", ")}.`
      );
    }
  } else if (!authorizationServers) {
    authorizationServer = options.issuerMetadata.credentialIssuer.credential_issuer;
  } else {
    if (authorizationServers.length === 0) {
      throw new import_oauth26.Oauth2Error(`Credential issuer metadata has 'authorization_servers' value with length of 0`);
    }
    if (authorizationServers.length > 1) {
      throw new import_oauth26.Oauth2Error(
        `Credential issuer metadata has 'authorization_server' with multiple entries, but the credential offer grant did not specify which authorization server to use.`
      );
    }
    authorizationServer = authorizationServers[0];
  }
  return authorizationServer;
}
async function createCredentialOffer(options) {
  const {
    [import_oauth26.preAuthorizedCodeGrantIdentifier]: preAuthorizedCodeGrant,
    [import_oauth26.authorizationCodeGrantIdentifier]: authorizationCodeGrant,
    ...restGrants
  } = options.grants;
  const grants = { ...restGrants };
  if (authorizationCodeGrant) {
    determineAuthorizationServerForCredentialOffer({
      issuerMetadata: options.issuerMetadata,
      grantAuthorizationServer: authorizationCodeGrant.authorization_server
    });
    grants[import_oauth26.authorizationCodeGrantIdentifier] = authorizationCodeGrant;
  }
  if (preAuthorizedCodeGrant) {
    determineAuthorizationServerForCredentialOffer({
      issuerMetadata: options.issuerMetadata,
      grantAuthorizationServer: preAuthorizedCodeGrant.authorization_server
    });
    grants[import_oauth26.preAuthorizedCodeGrantIdentifier] = {
      ...preAuthorizedCodeGrant,
      "pre-authorized_code": preAuthorizedCodeGrant["pre-authorized_code"] ?? (0, import_utils7.encodeToBase64Url)(await options.callbacks.generateRandom(32))
    };
    const txCode = grants[import_oauth26.preAuthorizedCodeGrantIdentifier].tx_code;
    if (txCode && options.issuerMetadata.originalDraftVersion === "Draft11" /* Draft11 */) {
      grants[import_oauth26.preAuthorizedCodeGrantIdentifier].user_pin_required = txCode !== void 0;
    }
  }
  const idsNotInMetadata = options.credentialConfigurationIds.filter(
    (id) => options.issuerMetadata.credentialIssuer.credential_configurations_supported[id] === void 0
  );
  if (idsNotInMetadata.length > 0) {
    throw new import_oauth26.Oauth2Error(
      `Credential configuration ids ${idsNotInMetadata} not found in the credential issuer metadata 'credential_configurations_supported'. Available ids are ${Object.keys(options.issuerMetadata.credentialIssuer.credential_configurations_supported).join(", ")}.`
    );
  }
  const credentialOfferScheme = options.credentialOfferScheme ?? "openid-credential-offer://";
  const credentialOfferObject = (0, import_utils7.parseWithErrorHandling)(vCredentialOfferObject, {
    credential_issuer: options.issuerMetadata.credentialIssuer.credential_issuer,
    credential_configuration_ids: options.credentialConfigurationIds,
    grants,
    ...options.additionalPayload
  });
  if (options.issuerMetadata.originalDraftVersion === "Draft11" /* Draft11 */) {
    credentialOfferObject.credentials = credentialOfferObject.credential_configuration_ids;
  }
  const url2 = new import_utils7.URL(credentialOfferScheme);
  url2.search = `?${new import_utils7.URLSearchParams([
    ...url2.searchParams.entries(),
    ...(0, import_utils7.objectToQueryParams)({
      credential_offer_uri: options.credentialOfferUri,
      // Only add credential_offer is uri is undefined
      credential_offer: options.credentialOfferUri ? void 0 : credentialOfferObject
    }).entries()
  ]).toString()}`;
  return {
    credentialOffer: url2.toString(),
    credentialOfferObject
  };
}

// src/credential-request/format-payload.ts
var v13 = __toESM(require("valibot"));
function getCredentialRequestFormatPayloadForCredentialConfigurationId(options) {
  const credentialConfiguration = options.issuerMetadata.credentialIssuer.credential_configurations_supported[options.credentialConfigurationId];
  if (!credentialConfiguration) {
    throw new Oid4vciError(
      `Could not find credential configuration with id '${options.credentialConfigurationId}' in metadata of credential issuer '${options.issuerMetadata.credentialIssuer.credential_issuer}'.`
    );
  }
  if (v13.is(vSdJwtVcCredentialIssuerMetadata, credentialConfiguration)) {
    return {
      format: credentialConfiguration.format,
      vct: credentialConfiguration.vct
    };
  }
  if (v13.is(vMsoMdocCredentialIssuerMetadata, credentialConfiguration)) {
    return {
      format: credentialConfiguration.format,
      doctype: credentialConfiguration.doctype
    };
  }
  if (v13.is(vLdpVcCredentialIssuerMetadata, credentialConfiguration)) {
    return {
      format: credentialConfiguration.format,
      credential_definition: {
        "@context": credentialConfiguration.credential_definition["@context"],
        type: credentialConfiguration.credential_definition.type
      }
    };
  }
  if (v13.is(vJwtVcJsonLdCredentialIssuerMetadata, credentialConfiguration)) {
    return {
      format: credentialConfiguration.format,
      credential_definition: {
        "@context": credentialConfiguration.credential_definition["@context"],
        type: credentialConfiguration.credential_definition.type
      }
    };
  }
  if (v13.is(vJwtVcJsonCredentialIssuerMetadata, credentialConfiguration)) {
    return {
      format: credentialConfiguration.format,
      credential_definition: {
        type: credentialConfiguration.credential_definition.type
      }
    };
  }
  throw new Oid4vciError(
    `Unknown format '${credentialConfiguration.format}' in credential configuration with id '${options.credentialConfigurationId}' for credential issuer '${options.issuerMetadata.credentialIssuer.credential_issuer}'`
  );
}

// src/credential-request/retrieve-credentials.ts
var import_oauth210 = require("@openid4vc/oauth2");
var import_utils9 = require("@openid4vc/utils");
var import_valibot = require("valibot");

// src/credential-request/v-credential-request.ts
var v17 = __toESM(require("valibot"));

// src/credential-request/v-credential-request-common.ts
var import_oauth29 = require("@openid4vc/oauth2");
var v16 = __toESM(require("valibot"));

// src/formats/proof-type/jwt/v-jwt-proof-type.ts
var v14 = __toESM(require("valibot"));
var import_oauth27 = require("@openid4vc/oauth2");
var import_utils8 = require("@openid4vc/utils");
var vJwtProofTypeIdentifier = v14.literal("jwt");
var jwtProofTypeIdentifier = vJwtProofTypeIdentifier.literal;
var vCredentialRequestProofJwt = v14.object({
  proof_type: vJwtProofTypeIdentifier,
  jwt: import_oauth27.vCompactJwt
});
var vCredentialRequestJwtProofTypeHeader = v14.pipe(
  v14.looseObject({
    ...import_oauth27.vJwtHeader.entries,
    key_attestation: v14.optional(import_oauth27.vCompactJwt),
    typ: v14.literal("openid4vci-proof+jwt")
  }),
  v14.check(
    ({ kid, jwk }) => jwk === void 0 || kid === void 0,
    `Both 'jwk' and 'kid' are defined. Only one is allowed`
  ),
  v14.check(({ trust_chain, kid }) => !trust_chain || !kid, `When 'trust_chain' is provided, 'kid' is required`)
);
var vCredentialRequestJwtProofTypePayload = v14.looseObject({
  ...import_oauth27.vJwtPayload.entries,
  aud: import_utils8.vHttpsUrl,
  iat: import_utils8.vInteger
});

// src/formats/proof-type/attestation/v-attestation-proof-type.ts
var v15 = __toESM(require("valibot"));
var import_oauth28 = require("@openid4vc/oauth2");
var vAttestationProofTypeIdentifier = v15.literal("attestation");
var attestationProofTypeIdentifier = vAttestationProofTypeIdentifier.literal;
var vCredentialRequestProofAttestation = v15.object({
  proof_type: vAttestationProofTypeIdentifier,
  attestation: import_oauth28.vCompactJwt
});
var vCredentialRequestAttestationProofTypePayload = vKeyAttestationJwtPayloadForUse("proof_type.attestation");

// src/credential-request/v-credential-request-common.ts
var vCredentialRequestProofCommon = v16.looseObject({
  proof_type: v16.string()
});
var allCredentialRequestProofs = [vCredentialRequestProofJwt, vCredentialRequestProofAttestation];
var allCredentialRequestProofsTypes = allCredentialRequestProofs.map((format) => format.entries.proof_type.literal);
var vCredentialRequestProof = v16.intersect([
  vCredentialRequestProofCommon,
  v16.variant("proof_type", [
    ...allCredentialRequestProofs,
    // To handle unrecognized proof_type values and not error immediately we allow the common format as well
    // but they can't use any of the proof_type identifiers already registered. This way if a proof_type is
    // recognized it NEEDS to use the proof_type specific validation, and otherwise we fall back to the common validation
    v16.looseObject({
      proof_type: v16.pipe(
        v16.string(),
        v16.check((input) => !allCredentialRequestProofsTypes.includes(input))
      )
    })
  ])
]);
var vCredentialRequestProofsCommon = v16.record(v16.string(), v16.array(v16.unknown()));
var vCredentialRequestProofs = v16.object({
  [vJwtProofTypeIdentifier.literal]: v16.optional(v16.array(vCredentialRequestProofJwt.entries.jwt)),
  [vAttestationProofTypeIdentifier.literal]: v16.optional(
    v16.array(vCredentialRequestProofAttestation.entries.attestation)
  )
});
var vCredentialRequestCommon = v16.pipe(
  v16.looseObject({
    proof: v16.optional(vCredentialRequestProof),
    proofs: v16.optional(
      v16.pipe(
        v16.intersect([vCredentialRequestProofsCommon, vCredentialRequestProofs]),
        // Only one proof type allowed per requet
        v16.check(
          (proofs) => Object.values(proofs).length === 1,
          `The 'proofs' object in a credential request should contain exactly one attribute`
        )
      )
    ),
    credential_response_encryption: v16.optional(
      v16.looseObject({
        jwk: import_oauth29.vJwk,
        alg: v16.string(),
        enc: v16.string()
      })
    )
  }),
  // It's not allowed to provide both proof and proofs
  v16.check(
    ({ proof, proofs }) => !(proof !== void 0 && proofs !== void 0),
    `Both 'proof' and 'proofs' are defined. Only one is allowed`
  )
);

// src/credential-request/v-credential-request.ts
var allCredentialRequestFormats = [
  vSdJwtVcCredentialRequestFormat,
  vMsoMdocCredentialRequestFormat,
  vLdpVcCredentialRequestFormat,
  vJwtVcJsonLdCredentialRequestFormat,
  vJwtVcJsonCredentialRequestFormat
];
var allCredentialRequestFormatIdentifiers = allCredentialRequestFormats.map(
  (format) => format.entries.format.literal
);
var vAuthorizationDetailsCredentialRequest = v17.object({
  credential_identifier: v17.string(),
  // Cannot be present if credential identifier is present
  format: v17.optional(v17.never("'format' cannot be defined when 'credential_identifier' is set."))
});
var vCredenialRequestDraft14WithFormat = v17.intersect([
  vCredentialRequestCommon,
  v17.union([
    ...allCredentialRequestFormats,
    // To handle unrecognized format values and not error immediately we allow the common format as well
    // but they can't use any of the format identifiers already registered. This way if a format is
    // recognized it NEEDS to use the format specific validation, and otherwise we fall back to the common validation
    v17.looseObject({
      format: v17.pipe(
        v17.string(),
        v17.check((input) => !allCredentialRequestFormatIdentifiers.includes(input))
      )
    })
  ]),
  v17.object({
    credential_identifier: v17.optional(v17.never("'credential_identifier' cannot be defined when 'format' is set."))
  })
]);
var vCredentialRequestDraft14 = v17.union([
  vCredenialRequestDraft14WithFormat,
  v17.intersect([vCredentialRequestCommon, vAuthorizationDetailsCredentialRequest])
]);
var vCredentialRequestDraft11To14 = v17.pipe(
  vCredentialRequestCommon,
  v17.intersect([
    v17.union([
      vLdpVcCredentialRequestDraft11To14,
      vJwtVcJsonLdCredentialRequestDraft11To14,
      vJwtVcJsonCredentialRequestDraft11To14
    ]),
    v17.object({
      credential_identifier: v17.optional(v17.never("'credential_identifier' cannot be defined when 'format' is set."))
    })
  ]),
  // Same as draft 14 but only for above used formats
  v17.intersect([
    vCredentialRequestCommon,
    v17.union([vLdpVcCredentialRequestFormat, vJwtVcJsonLdCredentialRequestFormat, vJwtVcJsonCredentialRequestFormat]),
    v17.object({
      credential_identifier: v17.optional(v17.never("'credential_identifier' cannot be defined when 'format' is set."))
    })
  ])
);
var vCredentialRequestDraft14To11 = v17.pipe(
  vCredentialRequestDraft14,
  v17.check(
    ({ credential_identifier }) => credential_identifier === void 0,
    `'credential_identifier' is not supported in OID4VCI draft 11`
  ),
  v17.union([
    vLdpVcCredentialRequestDraft14To11,
    vJwtVcJsonLdCredentialRequestDraft14To11,
    vJwtVcJsonCredentialRequestDraft14To11,
    // To handle unrecognized format values and not error immediately we allow the common format as well
    // but they can't use any of the format identifiers already registered. This way if a format is
    // recognized it NEEDS to use the format specific validation, and otherwise we fall back to the common validation
    v17.looseObject({
      format: v17.pipe(
        v17.string(),
        v17.check(
          (input) => ![
            vJwtVcJsonFormatIdentifier.literal,
            vJwtVcJsonLdFormatIdentifier.literal,
            vLdpVcFormatIdentifier.literal
          ].includes(input)
        )
      )
    })
  ])
);
var vCredentialRequest = v17.union([vCredentialRequestDraft14, vCredentialRequestDraft11To14]);

// src/credential-request/v-credential-response.ts
var v19 = __toESM(require("valibot"));

// ../oauth2/src/common/v-oauth2-error.ts
var v18 = __toESM(require("valibot"));
var Oauth2ErrorCodes = /* @__PURE__ */ ((Oauth2ErrorCodes4) => {
  Oauth2ErrorCodes4["ServerError"] = "server_error";
  Oauth2ErrorCodes4["InvalidTarget"] = "invalid_target";
  Oauth2ErrorCodes4["InvalidRequest"] = "invalid_request";
  Oauth2ErrorCodes4["InvalidToken"] = "invalid_token";
  Oauth2ErrorCodes4["InsufficientScope"] = "insufficient_scope";
  Oauth2ErrorCodes4["InvalidGrant"] = "invalid_grant";
  Oauth2ErrorCodes4["InvalidClient"] = "invalid_client";
  Oauth2ErrorCodes4["UnauthorizedClient"] = "unauthorized_client";
  Oauth2ErrorCodes4["UnsupportedGrantType"] = "unsupported_grant_type";
  Oauth2ErrorCodes4["InvalidScope"] = "invalid_scope";
  Oauth2ErrorCodes4["InvalidDpopProof"] = "invalid_dpop_proof";
  Oauth2ErrorCodes4["UseDpopNonce"] = "use_dpop_nonce";
  Oauth2ErrorCodes4["RedirectToWeb"] = "redirect_to_web";
  Oauth2ErrorCodes4["InvalidSession"] = "invalid_session";
  Oauth2ErrorCodes4["InsufficientAuthorization"] = "insufficient_authorization";
  Oauth2ErrorCodes4["InvalidCredentialRequest"] = "invalid_credential_request";
  Oauth2ErrorCodes4["CredentialRequestDenied"] = "credential_request_denied";
  Oauth2ErrorCodes4["UnsupportedCredentialType"] = "unsupported_credential_type";
  Oauth2ErrorCodes4["UnsupportedCredentialFormat"] = "unsupported_credential_format";
  Oauth2ErrorCodes4["InvalidProof"] = "invalid_proof";
  Oauth2ErrorCodes4["InvalidNonce"] = "invalid_nonce";
  Oauth2ErrorCodes4["InvalidEncryptionParameters"] = "invalid_encryption_parameters";
  return Oauth2ErrorCodes4;
})(Oauth2ErrorCodes || {});
var vOauth2ErrorResponse = v18.looseObject({
  error: v18.union([v18.enum(Oauth2ErrorCodes), v18.string()]),
  error_description: v18.optional(v18.string()),
  error_uri: v18.optional(v18.string())
});

// src/credential-request/v-credential-response.ts
var vCredentialEncoding = v19.union([v19.string(), v19.record(v19.string(), v19.any())]);
var vCredentialResponse = v19.pipe(
  v19.looseObject({
    credential: v19.optional(vCredentialEncoding),
    credentials: v19.optional(v19.array(vCredentialEncoding)),
    transaction_id: v19.optional(v19.string()),
    c_nonce: v19.optional(v19.string()),
    c_nonce_expires_in: v19.optional(v19.pipe(v19.number(), v19.integer())),
    notification_id: v19.optional(v19.string())
  }),
  v19.check(
    ({ credential, credentials, transaction_id }) => [credential, credentials, transaction_id].filter((i) => i !== void 0).length === 1,
    `Exactly one of 'credential', 'credentials', or 'transaction_id' MUST be defined.`
  )
);
var vCredentialErrorResponse = v19.looseObject({
  ...vOauth2ErrorResponse.entries,
  c_nonce: v19.optional(v19.string()),
  c_nonce_expires_in: v19.optional(v19.pipe(v19.number(), v19.integer()))
});

// src/credential-request/retrieve-credentials.ts
async function retrieveCredentialsWithFormat(options) {
  const credentialRequest = {
    ...options.formatPayload,
    ...options.additionalRequestPayload,
    proof: options.proof,
    proofs: options.proofs
  };
  return retrieveCredentials({
    callbacks: options.callbacks,
    credentialRequest,
    issuerMetadata: options.issuerMetadata,
    accessToken: options.accessToken,
    dpop: options.dpop
  });
}
async function retrieveCredentials(options) {
  const credentialEndpoint = options.issuerMetadata.credentialIssuer.credential_endpoint;
  let credentialRequest = (0, import_utils9.parseWithErrorHandling)(
    vCredentialRequest,
    options.credentialRequest,
    "Error validating credential request"
  );
  if (credentialRequest.proofs) {
    const { batch_credential_issuance } = options.issuerMetadata.credentialIssuer;
    if (!batch_credential_issuance) {
      throw new import_oauth210.Oauth2Error(
        `Credential issuer '${options.issuerMetadata.credentialIssuer.credential_issuer}' does not support batch credential issuance using the 'proofs' request property. Only 'proof' is supported.`
      );
    }
    const proofs = Object.values(credentialRequest.proofs)[0];
    if (proofs.length > batch_credential_issuance.batch_size) {
      throw new import_oauth210.Oauth2Error(
        `Credential issuer '${options.issuerMetadata.credentialIssuer.credential_issuer}' supports batch issuance, but the max batch size is '${batch_credential_issuance.batch_size}'. A total of '${proofs.length}' proofs were provided.`
      );
    }
  }
  if (options.issuerMetadata.originalDraftVersion === "Draft11" /* Draft11 */) {
    credentialRequest = (0, import_utils9.parseWithErrorHandling)(
      vCredentialRequestDraft14To11,
      credentialRequest,
      `Error transforming credential request from ${"Draft14" /* Draft14 */} to ${"Draft11" /* Draft11 */}`
    );
  }
  const resourceResponse = await (0, import_oauth210.resourceRequest)({
    dpop: options.dpop,
    accessToken: options.accessToken,
    callbacks: options.callbacks,
    url: credentialEndpoint,
    requestOptions: {
      method: "POST",
      headers: {
        "Content-Type": import_utils9.ContentType.Json
      },
      body: JSON.stringify(credentialRequest)
    }
  });
  if (!resourceResponse.ok) {
    const credentialErrorResponseResult = (0, import_utils9.isResponseContentType)(import_utils9.ContentType.Json, resourceResponse.response) ? (0, import_valibot.safeParse)(vCredentialErrorResponse, await resourceResponse.response.clone().json()) : void 0;
    return {
      ...resourceResponse,
      credentialErrorResponseResult
    };
  }
  const credentialResponseResult = (0, import_utils9.isResponseContentType)(import_utils9.ContentType.Json, resourceResponse.response) ? (0, import_valibot.safeParse)(vCredentialResponse, await resourceResponse.response.clone().json()) : void 0;
  if (!credentialResponseResult?.success) {
    return {
      ...resourceResponse,
      ok: false,
      credentialResponseResult
    };
  }
  return {
    ...resourceResponse,
    credentialResponse: credentialResponseResult.output
  };
}

// src/formats/proof-type/jwt/jwt-proof-type.ts
var import_oauth213 = require("@openid4vc/oauth2");
var import_oauth214 = require("@openid4vc/oauth2");
var import_utils11 = require("@openid4vc/utils");

// src/key-attestation/key-attestation.ts
var import_oauth211 = require("@openid4vc/oauth2");
var import_oauth212 = require("@openid4vc/oauth2");
var import_utils10 = require("@openid4vc/utils");
async function verifyKeyAttestationJwt(options) {
  const { header, payload } = (0, import_oauth211.decodeJwt)({
    jwt: options.keyAttestationJwt,
    headerSchema: vKeyAttestationJwtHeader,
    payloadSchema: vKeyAttestationJwtPayloadForUse(options.use)
  });
  const now = options.now?.getTime() ?? Date.now();
  if (options.nonceExpiresAt && now > options.nonceExpiresAt.getTime()) {
    throw new Oid4vciError("Nonce used for key attestation jwt expired");
  }
  const { signer } = await (0, import_oauth212.verifyJwt)({
    compact: options.keyAttestationJwt,
    header,
    payload,
    signer: (0, import_oauth212.jwtSignerFromJwt)({ header, payload }),
    verifyJwtCallback: options.callbacks.verifyJwt,
    errorMessage: "Error verifiying key attestation jwt",
    expectedNonce: options.expectedNonce,
    now: options.now
  });
  return {
    header,
    payload,
    signer
  };
}

// src/formats/proof-type/jwt/jwt-proof-type.ts
async function createCredentialRequestJwtProof(options) {
  const header = (0, import_utils11.parseWithErrorHandling)(vCredentialRequestJwtProofTypeHeader, {
    ...(0, import_oauth213.jwtHeaderFromJwtSigner)(options.signer),
    key_attestation: options.keyAttestationJwt,
    typ: "openid4vci-proof+jwt"
  });
  const payload = (0, import_utils11.parseWithErrorHandling)(vCredentialRequestJwtProofTypePayload, {
    nonce: options.nonce,
    aud: options.credentialIssuer,
    iat: (0, import_utils11.dateToSeconds)(options.issuedAt),
    iss: options.clientId
  });
  const { jwt, signerJwk } = await options.callbacks.signJwt(options.signer, { header, payload });
  if (options.keyAttestationJwt) {
    const decodedKeyAttestation = (0, import_oauth213.decodeJwt)({
      jwt: options.keyAttestationJwt,
      headerSchema: vKeyAttestationJwtHeader,
      payloadSchema: vKeyAttestationJwtPayload
    });
    const isSigedWithAttestedKey = await (0, import_oauth213.isJwkInSet)({
      jwk: signerJwk,
      jwks: decodedKeyAttestation.payload.attested_keys,
      callbacks: options.callbacks
    });
    if (!isSigedWithAttestedKey) {
      throw new Oid4vciError(
        `Credential request jwt proof is not signed with a key in the 'key_attestation' jwt payload 'attested_keys'`
      );
    }
  }
  return jwt;
}
async function verifyCredentialRequestJwtProof(options) {
  const { header, payload } = (0, import_oauth213.decodeJwt)({
    jwt: options.jwt,
    headerSchema: vCredentialRequestJwtProofTypeHeader,
    payloadSchema: vCredentialRequestJwtProofTypePayload
  });
  const now = options.now?.getTime() ?? Date.now();
  if (options.nonceExpiresAt && now > options.nonceExpiresAt.getTime()) {
    throw new Oid4vciError("Nonce used for credential request proof expired");
  }
  const { signer } = await (0, import_oauth214.verifyJwt)({
    compact: options.jwt,
    header,
    payload,
    signer: (0, import_oauth214.jwtSignerFromJwt)({ header, payload }),
    verifyJwtCallback: options.callbacks.verifyJwt,
    errorMessage: "Error verifiying credential request proof jwt",
    expectedNonce: options.expectedNonce,
    expectedAudience: options.credentialIssuer,
    expectedIssuer: options.clientId,
    now: options.now
  });
  let keyAttestationResult = void 0;
  if (header.key_attestation) {
    keyAttestationResult = await verifyKeyAttestationJwt({
      callbacks: options.callbacks,
      keyAttestationJwt: header.key_attestation,
      use: "proof_type.jwt"
    });
    const isSigedWithAttestedKey = await (0, import_oauth213.isJwkInSet)({
      jwk: signer.publicJwk,
      jwks: keyAttestationResult.payload.attested_keys,
      callbacks: options.callbacks
    });
    if (!isSigedWithAttestedKey) {
      throw new Oid4vciError(
        `Credential request jwt proof is not signed with a key in the 'key_attestation' jwt payload 'attested_keys'`
      );
    }
  }
  return {
    header,
    payload,
    signer,
    keyAttestation: keyAttestationResult
  };
}

// src/metadata/fetch-issuer-metadata.ts
var import_oauth215 = require("@openid4vc/oauth2");
var import_utils12 = require("@openid4vc/utils");
async function resolveIssuerMetadata(credentialIssuer, options) {
  const allowAuthorizationMetadataFromCredentialIssuerMetadata = options?.allowAuthorizationMetadataFromCredentialIssuerMetadata ?? true;
  const credentialIssuerMetadataWithDraftVersion = await fetchCredentialIssuerMetadata(credentialIssuer, options?.fetch);
  if (!credentialIssuerMetadataWithDraftVersion) {
    throw new import_oauth215.Oauth2Error(`Well known credential issuer metadata for issuer '${credentialIssuer}' not found.`);
  }
  const { credentialIssuerMetadata, originalDraftVersion } = credentialIssuerMetadataWithDraftVersion;
  const authorizationServers = credentialIssuerMetadata.authorization_servers ?? [credentialIssuer];
  const authoriationServersMetadata = [];
  for (const authorizationServer of authorizationServers) {
    if (options?.restrictToAuthorizationServers && !options.restrictToAuthorizationServers.includes(authorizationServer)) {
      continue;
    }
    let authorizationServerMetadata = await (0, import_oauth215.fetchAuthorizationServerMetadata)(authorizationServer, options?.fetch);
    if (!authorizationServerMetadata && authorizationServer === credentialIssuer && allowAuthorizationMetadataFromCredentialIssuerMetadata) {
      authorizationServerMetadata = (0, import_utils12.parseWithErrorHandling)(
        import_oauth215.vAuthorizationServerMetadata,
        {
          token_endpoint: credentialIssuerMetadata.token_endpoint,
          issuer: credentialIssuer
        },
        `Well known authorization server metadata for authorization server '${authorizationServer}' not found, and could also not extract required values from the credential issuer metadata as a fallback.`
      );
    }
    if (!authorizationServerMetadata) {
      throw new import_oauth215.Oauth2Error(
        `Well known openid configuration or authorization server metadata for authorization server '${authorizationServer}' not found.`
      );
    }
    authoriationServersMetadata.push(authorizationServerMetadata);
  }
  return {
    originalDraftVersion,
    credentialIssuer: credentialIssuerMetadata,
    authorizationServers: authoriationServersMetadata
  };
}

// src/nonce/nonce-request.ts
var import_oauth216 = require("@openid4vc/oauth2");
var import_utils14 = require("@openid4vc/utils");

// src/nonce/v-nonce.ts
var import_utils13 = require("@openid4vc/utils");
var v20 = __toESM(require("valibot"));
var vNonceResponse = v20.looseObject({
  c_nonce: v20.string(),
  c_nonce_expires_in: v20.optional(import_utils13.vInteger)
});

// src/nonce/nonce-request.ts
async function requestNonce(options) {
  const fetchWithValibot = (0, import_utils14.createValibotFetcher)(options?.fetch);
  const nonceEndpoint = options.issuerMetadata.credentialIssuer.nonce_endpoint;
  if (!nonceEndpoint) {
    throw new Oid4vciError(
      `Credential issuer '${options.issuerMetadata.credentialIssuer.credential_issuer}' does not have a nonce endpoint.`
    );
  }
  const { response, result } = await fetchWithValibot(vNonceResponse, import_utils14.ContentType.Json, nonceEndpoint, {
    method: "POST"
  });
  if (!response.ok || !result) {
    throw new import_oauth216.InvalidFetchResponseError(
      `Requesting nonce from '${nonceEndpoint}' resulted in an unsuccesfull response with status '${response.status}'`,
      await response.clone().text(),
      response
    );
  }
  if (result.issues) {
    throw new import_utils14.ValidationError("Error parsing nonce response", result.issues);
  }
  return result.output;
}
function createNonceResponse(options) {
  return (0, import_utils14.parseWithErrorHandling)(vNonceResponse, {
    c_nonce: options.cNonce,
    c_nonce_expires_in: options.cNonceExpiresIn,
    ...options.additionalPayload
  });
}

// src/notification/notification.ts
var v22 = __toESM(require("valibot"));
var import_oauth217 = require("@openid4vc/oauth2");
var import_utils15 = require("@openid4vc/utils");

// src/notification/v-notification.ts
var v21 = __toESM(require("valibot"));
var vNotificationEvent = v21.picklist(["credential_accepted", "credential_failure", "credential_deleted"]);
var vNotificationRequest = v21.looseObject({
  notification_id: v21.string(),
  event: vNotificationEvent,
  event_description: v21.optional(v21.string())
});
var vNotificationErrorResponse = v21.looseObject({
  error: v21.picklist(["invalid_notification_id", "invalid_notification_request"])
});

// src/notification/notification.ts
async function sendNotifcation(options) {
  const notificationEndpoint = options.issuerMetadata.credentialIssuer.notification_endpoint;
  if (!notificationEndpoint) {
    throw new import_oauth217.Oauth2Error(
      `Credential issuer '${options.issuerMetadata.credentialIssuer.credential_issuer}' does not have a notification endpiont configured.`
    );
  }
  const notificationRequest = (0, import_utils15.parseWithErrorHandling)(
    vNotificationRequest,
    {
      event: options.notification.event,
      notification_id: options.notification.notificationId,
      event_description: options.notification.eventDescription
    },
    "Error validating notification request"
  );
  const resourceResponse = await (0, import_oauth217.resourceRequest)({
    dpop: options.dpop,
    accessToken: options.accessToken,
    callbacks: options.callbacks,
    url: notificationEndpoint,
    requestOptions: {
      method: "POST",
      headers: {
        "Content-Type": import_utils15.ContentType.Json
      },
      body: JSON.stringify(notificationRequest)
    }
  });
  if (!resourceResponse.ok) {
    const notificationErrorResponseResult = (0, import_utils15.isResponseContentType)(import_utils15.ContentType.Json, resourceResponse.response) ? v22.safeParse(vNotificationErrorResponse, await resourceResponse.response.clone().json()) : void 0;
    return {
      ...resourceResponse,
      notificationErrorResponseResult
    };
  }
  return resourceResponse;
}

// src/Oid4vciClient.ts
var AuthorizationFlow = /* @__PURE__ */ ((AuthorizationFlow2) => {
  AuthorizationFlow2["Oauth2Redirect"] = "Oauth2Redirect";
  AuthorizationFlow2["PresentationDuringIssuance"] = "PresentationDuringIssuance";
  return AuthorizationFlow2;
})(AuthorizationFlow || {});
var Oid4vciClient = class {
  constructor(options) {
    this.options = options;
    this.oauth2Client = new import_oauth218.Oauth2Client({
      callbacks: this.options.callbacks
    });
  }
  getKnownCredentialConfigurationsSupported(credentialIssuerMetadata) {
    return extractKnownCredentialConfigurationSupportedFormats(
      credentialIssuerMetadata.credential_configurations_supported
    );
  }
  /**
   * Resolve a credential offer into a credential offer object, handling both
   * 'credential_offer' and 'credential_offer_uri' params.
   */
  async resolveCredentialOffer(credentialOffer) {
    return resolveCredentialOffer(credentialOffer, {
      fetch: this.options.callbacks.fetch
    });
  }
  async resolveIssuerMetadata(credentialIssuer) {
    return resolveIssuerMetadata(credentialIssuer, {
      fetch: this.options.callbacks.fetch
    });
  }
  /**
   * Retrieve an authorization code for a presentation during issuance session
   *
   * This can only be called if an authorization challenge was performed before and returned a
   * `presentation` paramater along with an `auth_session`. If the presentation response included
   * an `presentation_during_issuance_session` parameter it MUST be included in this request as well.
   */
  async retrieveAuthorizationCodeUsingPresentation(options) {
    if (!options.credentialOffer.grants?.[import_oauth218.authorizationCodeGrantIdentifier]) {
      throw new import_oauth218.Oauth2Error(`Provided credential offer does not include the 'authorization_code' grant.`);
    }
    const authorizationCodeGrant = options.credentialOffer.grants[import_oauth218.authorizationCodeGrantIdentifier];
    const authorizationServer = determineAuthorizationServerForCredentialOffer({
      issuerMetadata: options.issuerMetadata,
      grantAuthorizationServer: authorizationCodeGrant.authorization_server
    });
    const authorizationServerMetadata = (0, import_oauth218.getAuthorizationServerMetadataFromList)(
      options.issuerMetadata.authorizationServers,
      authorizationServer
    );
    const oauth2Client = new import_oauth218.Oauth2Client({ callbacks: this.options.callbacks });
    const { authorizationChallengeResponse, dpop } = await oauth2Client.sendAuthorizationChallengeRequest({
      authorizationServerMetadata,
      authSession: options.authSession,
      presentationDuringIssuanceSession: options.presentationDuringIssuanceSession,
      dpop: options.dpop
    });
    return { authorizationChallengeResponse, dpop };
  }
  /**
   * Initiates authorization for credential issuance. It handles the following cases:
   * - Authorization Challenge
   * - Pushed Authorization Request
   * - Regular Authorization url
   *
   * In case the authorization challenge request returns an error with `insufficient_authorization`
   * with a `presentation` field it means the authorization server expects presentation of credentials
   * before issuance of crednetials. If this is the case, the value in `presentation` should be treated
   * as an openid4vp authorization request and submitted to the verifier. Once the presentation response
   * has been submitted, the RP will respnosd with a `presentation_during_issuance_session` parameter.
   * Together with the `auth_session` parameter returned in this call you can retrieve an `authorization_code`
   * using
   */
  async initiateAuthorization(options) {
    if (!options.credentialOffer.grants?.[import_oauth218.authorizationCodeGrantIdentifier]) {
      throw new import_oauth218.Oauth2Error(`Provided credential offer does not include the 'authorization_code' grant.`);
    }
    const authorizationCodeGrant = options.credentialOffer.grants[import_oauth218.authorizationCodeGrantIdentifier];
    const authorizationServer = determineAuthorizationServerForCredentialOffer({
      issuerMetadata: options.issuerMetadata,
      grantAuthorizationServer: authorizationCodeGrant.authorization_server
    });
    const authorizationServerMetadata = (0, import_oauth218.getAuthorizationServerMetadataFromList)(
      options.issuerMetadata.authorizationServers,
      authorizationServer
    );
    const oauth2Client = new import_oauth218.Oauth2Client({ callbacks: this.options.callbacks });
    try {
      const result = await oauth2Client.initiateAuthorization({
        clientId: options.clientId,
        pkceCodeVerifier: options.pkceCodeVerifier,
        redirectUri: options.redirectUri,
        scope: options.scope,
        additionalRequestPayload: {
          ...options.additionalRequestPayload,
          issuer_state: options.credentialOffer?.grants?.authorization_code?.issuer_state
        },
        dpop: options.dpop,
        clientAttestation: options.clientAttestation,
        resource: options.issuerMetadata.credentialIssuer.credential_issuer,
        authorizationServerMetadata
      });
      return {
        ...result,
        authorizationFlow: "Oauth2Redirect" /* Oauth2Redirect */,
        authorizationServer: authorizationServerMetadata.issuer
      };
    } catch (error) {
      if (error instanceof import_oauth218.Oauth2ClientAuthorizationChallengeError && error.errorResponse.error === import_oauth218.Oauth2ErrorCodes.InsufficientAuthorization && error.errorResponse.presentation) {
        if (!error.errorResponse.auth_session) {
          throw new Oid4vciError(
            `Expected 'auth_session' to be defined with authorization challenge response error '${error.errorResponse.error}' and 'presentation' parameter`
          );
        }
        return {
          authorizationFlow: "PresentationDuringIssuance" /* PresentationDuringIssuance */,
          oid4vpRequestUrl: error.errorResponse.presentation,
          authSession: error.errorResponse.auth_session,
          authorizationServer: authorizationServerMetadata.issuer
        };
      }
      throw error;
    }
  }
  /**
   * Convenience method around {@link Oauth2Client.createAuthorizationRequestUrl}
   * but specifically focused on a credential offer
   */
  async createAuthorizationRequestUrlFromOffer(options) {
    if (!options.credentialOffer.grants?.[import_oauth218.authorizationCodeGrantIdentifier]) {
      throw new import_oauth218.Oauth2Error(`Provided credential offer does not include the 'authorization_code' grant.`);
    }
    const authorizationCodeGrant = options.credentialOffer.grants[import_oauth218.authorizationCodeGrantIdentifier];
    const authorizationServer = determineAuthorizationServerForCredentialOffer({
      issuerMetadata: options.issuerMetadata,
      grantAuthorizationServer: authorizationCodeGrant.authorization_server
    });
    const authorizationServerMetadata = (0, import_oauth218.getAuthorizationServerMetadataFromList)(
      options.issuerMetadata.authorizationServers,
      authorizationServer
    );
    const { authorizationRequestUrl, pkce, dpop } = await this.oauth2Client.createAuthorizationRequestUrl({
      authorizationServerMetadata,
      clientId: options.clientId,
      additionalRequestPayload: {
        ...options.additionalRequestPayload,
        issuer_state: options.credentialOffer?.grants?.authorization_code?.issuer_state
      },
      resource: options.issuerMetadata.credentialIssuer.credential_issuer,
      redirectUri: options.redirectUri,
      scope: options.scope,
      pkceCodeVerifier: options.pkceCodeVerifier,
      clientAttestation: options.clientAttestation,
      dpop: options.dpop
    });
    return {
      authorizationRequestUrl,
      pkce,
      dpop,
      authorizationServer: authorizationServerMetadata.issuer
    };
  }
  /**
   * Convenience method around {@link Oauth2Client.retrievePreAuthorizedCodeAccessToken}
   * but specifically focused on a credential offer
   */
  async retrievePreAuthorizedCodeAccessTokenFromOffer({
    credentialOffer,
    issuerMetadata,
    additionalRequestPayload,
    txCode,
    dpop,
    clientAttestation
  }) {
    if (!credentialOffer.grants?.[import_oauth218.preAuthorizedCodeGrantIdentifier]) {
      throw new import_oauth218.Oauth2Error(`The credential offer does not contain the '${import_oauth218.preAuthorizedCodeGrantIdentifier}' grant.`);
    }
    if (credentialOffer.grants[import_oauth218.preAuthorizedCodeGrantIdentifier].tx_code && !txCode) {
      throw new import_oauth218.Oauth2Error(
        `Retrieving access token requires a 'tx_code' in the request, but the 'txCode' parameter was not provided.`
      );
    }
    const preAuthorizedCode = credentialOffer.grants[import_oauth218.preAuthorizedCodeGrantIdentifier]["pre-authorized_code"];
    const authorizationServer = determineAuthorizationServerForCredentialOffer({
      grantAuthorizationServer: credentialOffer.grants[import_oauth218.preAuthorizedCodeGrantIdentifier].authorization_server,
      issuerMetadata
    });
    const authorizationServerMetadata = (0, import_oauth218.getAuthorizationServerMetadataFromList)(
      issuerMetadata.authorizationServers,
      authorizationServer
    );
    const result = await this.oauth2Client.retrievePreAuthorizedCodeAccessToken({
      authorizationServerMetadata,
      preAuthorizedCode,
      txCode,
      resource: issuerMetadata.credentialIssuer.credential_issuer,
      additionalRequestPayload,
      dpop,
      clientAttestation
    });
    return {
      ...result,
      authorizationServer
    };
  }
  /**
   * Convenience method around {@link Oauth2Client.retrieveAuthorizationCodeAccessTokenFrom}
   * but specifically focused on a credential offer
   */
  async retrieveAuthorizationCodeAccessTokenFromOffer({
    issuerMetadata,
    additionalRequestPayload,
    credentialOffer,
    authorizationCode,
    pkceCodeVerifier,
    redirectUri,
    dpop,
    clientAttestation
  }) {
    if (!credentialOffer.grants?.[import_oauth218.authorizationCodeGrantIdentifier]) {
      throw new import_oauth218.Oauth2Error(`The credential offer does not contain the '${import_oauth218.authorizationCodeGrantIdentifier}' grant.`);
    }
    const authorizationServer = determineAuthorizationServerForCredentialOffer({
      grantAuthorizationServer: credentialOffer.grants[import_oauth218.authorizationCodeGrantIdentifier].authorization_server,
      issuerMetadata
    });
    const authorizationServerMetadata = (0, import_oauth218.getAuthorizationServerMetadataFromList)(
      issuerMetadata.authorizationServers,
      authorizationServer
    );
    const result = await this.oauth2Client.retrieveAuthorizationCodeAccessToken({
      authorizationServerMetadata,
      authorizationCode,
      pkceCodeVerifier,
      additionalRequestPayload,
      dpop,
      clientAttestation,
      redirectUri,
      resource: issuerMetadata.credentialIssuer.credential_issuer
    });
    return {
      ...result,
      authorizationServer
    };
  }
  /**
   * Request a nonce to be used in credential request proofs from the `nonce_endpoint`
   *
   * @throws Oid4vciError - if no `nonce_endpoint` is configured in the issuer metadata
   * @thrwos InvalidFetchResponseError - if the nonce endpoint did not return a succesfull response
   * @throws ValidationError - if validating the nonce response failed
   */
  async requestNonce(options) {
    return requestNonce(options);
  }
  /**
   * Creates the jwt proof payload and header to be included in a credential request.
   */
  async createCredentialRequestJwtProof(options) {
    const credentialConfiguration = options.issuerMetadata.credentialIssuer.credential_configurations_supported[options.credentialConfigurationId];
    if (!credentialConfiguration) {
      throw new Oid4vciError(
        `Credential configuration with '${options.credentialConfigurationId}' not found in 'credential_configurations_supported' from credential issuer '${options.issuerMetadata.credentialIssuer.credential_issuer}'`
      );
    }
    if (credentialConfiguration.proof_types_supported) {
      if (!credentialConfiguration.proof_types_supported.jwt) {
        throw new Oid4vciError(
          `Credential configuration with id '${options.credentialConfigurationId}' does not support the 'jwt' proof type.`
        );
      }
      if (!credentialConfiguration.proof_types_supported.jwt.proof_signing_alg_values_supported.includes(
        options.signer.alg
      )) {
        throw new Oid4vciError(
          `Credential configuration with id '${options.credentialConfigurationId}' does not support the '${options.signer.alg}' alg for 'jwt' proof type.`
        );
      }
      if (credentialConfiguration.proof_types_supported.jwt.key_attestations_required && !options.keyAttestationJwt) {
        throw new Oid4vciError(
          `Credential configuration with id '${options.credentialConfigurationId}' requires key attestations for 'jwt' proof type but no 'keyAttestationJwt' was provided`
        );
      }
    }
    const jwt = await createCredentialRequestJwtProof({
      credentialIssuer: options.issuerMetadata.credentialIssuer.credential_issuer,
      signer: options.signer,
      clientId: options.clientId,
      issuedAt: options.issuedAt,
      nonce: options.nonce,
      keyAttestationJwt: options.keyAttestationJwt,
      callbacks: this.options.callbacks
    });
    return {
      jwt
    };
  }
  /**
   * @throws Oid4vciRetrieveCredentialsError - if an unsuccesfull response or the respnose couldn't be parsed as credential response
   * @throws ValidationError - if validation of the credential request failed
   * @throws Oid4vciError - if the `credentialConfigurationId` couldn't be found, or if the the format specific request couldn't be constructed
   */
  async retrieveCredentials({
    issuerMetadata,
    proof,
    proofs,
    credentialConfigurationId,
    additionalRequestPayload,
    accessToken,
    dpop
  }) {
    const formatPayload = getCredentialRequestFormatPayloadForCredentialConfigurationId({
      credentialConfigurationId,
      issuerMetadata
    });
    const credentialResponse = await retrieveCredentialsWithFormat({
      accessToken,
      formatPayload,
      issuerMetadata,
      additionalRequestPayload,
      proof,
      proofs,
      callbacks: this.options.callbacks,
      dpop
    });
    if (!credentialResponse.ok) {
      throw new Oid4vciRetrieveCredentialsError(
        `Error retrieving credentials from '${issuerMetadata.credentialIssuer.credential_issuer}'`,
        credentialResponse,
        await credentialResponse.response.clone().text()
      );
    }
    return credentialResponse;
  }
  /**
   * @throws Oid4vciSendNotificationError - if an unsuccesfull response
   * @throws ValidationError - if validation of the notification request failed
   */
  async sendNotification({
    issuerMetadata,
    notification,
    additionalRequestPayload,
    accessToken,
    dpop
  }) {
    const notificationResponse = await sendNotifcation({
      accessToken,
      issuerMetadata,
      additionalRequestPayload,
      callbacks: this.options.callbacks,
      dpop,
      notification
    });
    if (!notificationResponse.ok) {
      throw new Oid4vciSendNotificationError(
        `Error sending notification to '${issuerMetadata.credentialIssuer.credential_issuer}'`,
        notificationResponse
      );
    }
    return notificationResponse;
  }
};

// src/Oid4vciIssuer.ts
var import_oauth219 = require("@openid4vc/oauth2");
var import_utils18 = require("@openid4vc/utils");

// src/credential-request/credential-response.ts
var import_utils16 = require("@openid4vc/utils");
function createCredentialResponse(options) {
  const credentialResponse = (0, import_utils16.parseWithErrorHandling)(vCredentialResponse, {
    c_nonce: options.cNonce,
    c_nonce_expires_in: options.cNonceExpiresInSeconds,
    credential: options.credential,
    credentials: options.credentials,
    notification_id: options.notificationId,
    // NOTE `format` is removed in draft 13. For now if a format was requested
    // we just always return it in the response as well.
    format: options.credentialRequest.format?.format,
    ...options.additionalPayload
  });
  return credentialResponse;
}

// src/credential-request/parse-credential-request.ts
var import_utils17 = require("@openid4vc/utils");
var v23 = __toESM(require("valibot"));
function parseCredentialRequest(options) {
  const credentialRequest = (0, import_utils17.parseWithErrorHandling)(
    vCredentialRequest,
    options.credentialRequest,
    "Error validating credential request"
  );
  let proofs = void 0;
  const knownProofs = v23.safeParse(v23.strictObject({ ...vCredentialRequestProofs.entries }), credentialRequest.proofs);
  if (knownProofs.success) {
    proofs = knownProofs.output;
  }
  const knownProof = v23.safeParse(v23.union(allCredentialRequestProofs), credentialRequest.proof);
  if (knownProof.success && knownProof.output.proof_type === jwtProofTypeIdentifier) {
    proofs = { [jwtProofTypeIdentifier]: [knownProof.output.jwt] };
  } else if (knownProof.success && knownProof.output.proof_type === attestationProofTypeIdentifier) {
    proofs = { [attestationProofTypeIdentifier]: [knownProof.output.attestation] };
  }
  if (credentialRequest.credential_identifier) {
    return {
      credentialIdentifier: credentialRequest.credential_identifier,
      credentialRequest,
      proofs
    };
  }
  if (credentialRequest.format && allCredentialRequestFormatIdentifiers.includes(credentialRequest.format)) {
    return {
      // Removes all claims that are not specific to this format
      format: (0, import_utils17.parseWithErrorHandling)(
        v23.union(allCredentialRequestFormats),
        credentialRequest,
        "Unable to validate format specific properties from credential request"
      ),
      credentialRequest,
      proofs
    };
  }
  return {
    credentialRequest,
    proofs
  };
}

// src/formats/proof-type/attestation/attestation-proof-type.ts
async function verifyCredentialRequestAttestationProof(options) {
  const verificationResult = await verifyKeyAttestationJwt({
    ...options,
    use: "proof_type.attestation"
  });
  return verificationResult;
}

// src/Oid4vciIssuer.ts
var Oid4vciIssuer = class {
  constructor(options) {
    this.options = options;
  }
  getCredentialIssuerMetadataDraft11(credentialIssuerMetadata) {
    return (0, import_utils18.parseWithErrorHandling)(vCredentialIssuerMetadataWithDraft11, credentialIssuerMetadata);
  }
  getKnownCredentialConfigurationsSupported(credentialIssuerMetadata) {
    return extractKnownCredentialConfigurationSupportedFormats(
      credentialIssuerMetadata.credential_configurations_supported
    );
  }
  /**
   * Create issuer metadata and validates the structure is correct
   */
  createCredentialIssuerMetadata(credentialIssuerMetadata) {
    return (0, import_utils18.parseWithErrorHandling)(
      vCredentialIssuerMetadata,
      credentialIssuerMetadata,
      "Error validating credential issuer metadata"
    );
  }
  async createCredentialOffer(options) {
    return createCredentialOffer({
      callbacks: this.options.callbacks,
      credentialConfigurationIds: options.credentialConfigurationIds,
      grants: options.grants,
      issuerMetadata: options.issuerMetadata,
      additionalPayload: options.additionalPayload,
      credentialOfferScheme: options.credentialOfferScheme,
      credentialOfferUri: options.credentialOfferUri
    });
  }
  /**
   * @throws Oauth2ServerErrorResponseError - if verification of the jwt failed. You can extract
   *  the credential error response from this.
   */
  async verifyCredentialRequestJwtProof(options) {
    try {
      return await verifyCredentialRequestJwtProof({
        callbacks: this.options.callbacks,
        credentialIssuer: options.issuerMetadata.credentialIssuer.credential_issuer,
        expectedNonce: options.expectedNonce,
        nonceExpiresAt: options.nonceExpiresAt,
        jwt: options.jwt,
        clientId: options.clientId,
        now: options.now
      });
    } catch (error) {
      throw new import_oauth219.Oauth2ServerErrorResponseError(
        {
          error: import_oauth219.Oauth2ErrorCodes.InvalidProof,
          error_description: (
            // TOOD: error should have a internalErrorMessage and a publicErrorMessage
            error instanceof import_oauth219.Oauth2JwtVerificationError || error instanceof Oid4vciError ? error.message : "Invalid proof"
          )
        },
        {
          internalMessage: "Error verifying credential request proof jwt",
          cause: error
        }
      );
    }
  }
  /**
   * @throws Oauth2ServerErrorResponseError - if verification of the key attestation failed. You can extract
   *  the credential error response from this.
   */
  async verifyCredentialRequestAttestationProof(options) {
    try {
      return await verifyCredentialRequestAttestationProof({
        callbacks: this.options.callbacks,
        expectedNonce: options.expectedNonce,
        keyAttestationJwt: options.keyAttestationJwt,
        nonceExpiresAt: options.nonceExpiresAt,
        now: options.now
      });
    } catch (error) {
      throw new import_oauth219.Oauth2ServerErrorResponseError(
        {
          error: import_oauth219.Oauth2ErrorCodes.InvalidProof,
          error_description: (
            // TOOD: error should have a internalErrorMessage and a publicErrorMessage
            error instanceof import_oauth219.Oauth2JwtVerificationError || error instanceof Oid4vciError ? error.message : "Invalid proof"
          )
        },
        {
          internalMessage: "Error verifying credential request proof attestation",
          cause: error
        }
      );
    }
  }
  /**
   * @throws Oauth2ServerErrorResponseError - when validation of the credential request fails
   *  You can extract the credential error response from this.
   */
  parseCredentialRequest(options) {
    try {
      return parseCredentialRequest(options);
    } catch (error) {
      throw new import_oauth219.Oauth2ServerErrorResponseError(
        {
          error: import_oauth219.Oauth2ErrorCodes.InvalidCredentialRequest,
          error_description: (
            // TODO: error should have a internalErrorMessage and a publicErrorMessage
            error instanceof import_utils18.ValidationError ? error.message : "Invalid request"
          )
        },
        {
          internalMessage: "Error verifying credential request proof jwt",
          cause: error
        }
      );
    }
  }
  /**
   * @throws ValidationError - when validation of the credential response fails
   */
  createCredentialResponse(options) {
    return createCredentialResponse(options);
  }
  /**
   * @throws ValidationError - when validation of the nonce response fails
   */
  createNonceResponse(options) {
    return createNonceResponse(options);
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  AuthorizationFlow,
  Oid4vciClient,
  Oid4vciDraftVersion,
  Oid4vciError,
  Oid4vciIssuer,
  Oid4vciRetrieveCredentialsError,
  Oid4vciSendNotificationError,
  credentialsSupportedToCredentialConfigurationsSupported,
  extractScopesForCredentialConfigurationIds,
  getCredentialConfigurationsMatchingRequestFormat,
  getGlobalConfig,
  setGlobalConfig
});
//# sourceMappingURL=index.js.map